/*
* -----------------------------------------
* All code Copyright (c), C. Cookson, 2000
*            C.J.Cookson@dcs.warwick.ac.uk
*                    cjcookson@hotmail.com
* -----------------------------------------
*/

/*
*	3dmaths.h
*	--
*	3d maths core module header
*	--
*/

#ifndef __H3DMATHS__
#define __H3DMATHS__

#ifndef SQR
#define SQR(x) ((x) * (x))
#endif

void addVector (GLfloat *a ,GLfloat *b );
void normalize (GLfloat *v );
GLfloat magnitude (GLfloat *v );
GLfloat dotProduct (GLfloat *u ,GLfloat *v );
GLfloat *crossProduct (GLfloat *u ,GLfloat *v );
void makeIdentity (GLfloat *matrix );
void makeRotateX (GLfloat *matrix, float a );
void makeRotateY (GLfloat *matrix, float a );
void makeRotateZ (GLfloat *matrix, float a );
void translateInPlace (GLfloat *m ,GLfloat dx ,GLfloat dy ,GLfloat dz );
void concatenate (GLfloat * m1 ,GLfloat * m2 );
void rotate(GLfloat *t, GLfloat *vector);
void transform (GLfloat * t ,GLfloat * vector );

#endif
