#include <windows.h>

#include "CFace.h"

CFace::CFace()	// Constructeur par dfaut
{
	this->Vertex = CIndice3(0,0,0);
	this->Normal = CIndice3(0,0,0);
	this->TexCoord = CIndice3(0,0,0);
	this->pVertices = NULL;
	this->pNormals = NULL;
}

CFace::CFace(CIndice3 &v,CIndice3 &n,CIndice3 &t,CVector3 *pV,CVector3 *pN)	// Constructeur  partir de 3 indices + pointeurs sur le tableau contenant les donnes
{
	this->Vertex = v;
	this->Normal = n;
	this->TexCoord = t;
	this->pVertices = pV;
	this->pNormals = pN;
}

CFace::CFace(unsigned int v1, unsigned int v2,unsigned int v3, unsigned int n1, unsigned int n2, unsigned int n3, unsigned int t1, unsigned int t2, unsigned int t3,CVector3 *pV,CVector3 *pN)	// Constructeur  partir de 9 indices + pointeurs sur le tableau contenant les donnes
{
	this->Vertex = CIndice3(v1,v2,v3);
	this->Normal = CIndice3(n1,n2,n3);
	this->TexCoord = CIndice3(t1,t2,t3);
	this->pVertices = pV;
	this->pNormals = pN;
}

CFace::CFace(CFace &f)	//	Constructeur par duplication
{
	*this = f;
}

CFace::~CFace(void)	// Destructeur
{
	this->pVertices = NULL;
	this->pNormals = NULL;
}

CVector4 CFace::CalculatePlane()	// calcule l'quation du plan dont fait partie la face et renvoie les valeurs du plan
{
	// on dfini des noms plus court
#define V1x this->pVertices[this->Vertex.abc[0]].xyz[0]
#define V1y this->pVertices[this->Vertex.abc[0]].xyz[1]
#define V1z this->pVertices[this->Vertex.abc[0]].xyz[2]
#define V2x this->pVertices[this->Vertex.abc[1]].xyz[0]
#define V2y this->pVertices[this->Vertex.abc[1]].xyz[1]
#define V2z this->pVertices[this->Vertex.abc[1]].xyz[2]
#define	V3x this->pVertices[this->Vertex.abc[2]].xyz[0]
#define	V3y this->pVertices[this->Vertex.abc[2]].xyz[1]
#define	V3z this->pVertices[this->Vertex.abc[2]].xyz[2]

	return CVector4(V1y*(V2z-V3z) + V2y*(V3z-V1z) + V3y*(V1z-V2z),
					V1z*(V2x-V3x) + V2z*(V3x-V1x) + V3z*(V1x-V2x),
					V1x*(V2y-V3y) + V2x*(V3y-V1y) + V3x*(V1y-V2y),
					-( V1x*(V2y*V3z - V3y*V2z) + V2x*(V3y*V1z - V1y*V3z) + V3x*(V1y*V2z - V2y*V1z) )
					);
	// juste pour la fonction
#undef V1x
#undef V1y
#undef V1z
#undef V2x
#undef V2y
#undef V2z
#undef V3x
#undef V3y
#undef V3z
}

//////////////////////////////
//	Les oprateurs simples	//
//////////////////////////////

void CFace::operator = (CFace &v)
{
	this->Vertex = v.Vertex;
	this->Normal = v.Normal;
	this->TexCoord = v.TexCoord;
	this->pVertices = v.pVertices;
	this->pNormals = v.pNormals;
}

//////////////////////////////
//	Les oprateurs de test	//
//////////////////////////////

bool CFace::operator == (CFace &v)
{
	return (this->Vertex==v.Vertex);
}

bool CFace::operator != (CFace &v)
{
	return (this->Vertex!=v.Vertex);
}

CFace_ShadowVolume::CFace_ShadowVolume()	// constructeur
{
	this->pFather = NULL;
}

CFace_ShadowVolume::~CFace_ShadowVolume()	// destructeur
{
	if (this->pFather)
		this->pFather = NULL;
}
