#ifndef __HCFastMaths__
#define __HCFastMaths__

#define MYMATHS_PI 3.1415926535897932384626433832795f
#define MYMATHS_PIDIV2 1.5707963267948966192313216916398f
#define MYMATHS_TABRANGE 15000

class CFastMaths {
private:
	float *_tdeg;
	float *_tsin;
	float *_tcos;
	float *_trad;
public:
	CFastMaths(void);
	~CFastMaths(void);
	float FastCosDeg(float angle);
	float FastCosRad(float angle);
	float FastSinDeg(float angle);
	float FastSinRad(float angle);
	float FastAcosDeg(float c);
	float FastAcosRad(float c);
	float FastAsinDeg(float s);
	float FastAsinRad(float s);

	float MyCosDeg(float angle);
	float MyCosRad(float angle);
	float MySinDeg(float angle);
	float MySinRad(float angle);
	float MyAcosDeg(float c);
	float MyAcosRad(float c);
	float MyAsinDeg(float s);
	float MyAsinRad(float s);

	float FastRad2Deg(float rad);
	float FastDeg2Rad(float deg);
	float MyRad2Deg(float rad);
	float MyDeg2Rad(float deg);
};

#endif // __HCFastMaths__
