#ifndef __HCFrustum__
#define __HCFrustum__

#include "CVector3.h"
#include "CVector4.h"

class CFrustum {
public:
	CFrustum(void);	// constructeur
	~CFrustum(void);	// destructeur
	void CalculateFrustum(void); // met  jour le frustum en recalculant les plans
	bool PointInFrustum(float x,float y,float z);	// teste si un point est dans le frustum
	bool PointInFrustum(CVector3 &pos);	// teste si un point est dans le frustum
	bool SphereInFrustum(float x,float y,float z,float rayon);	// teste si une sphere est dans le frustum
	bool SphereInFrustum(CVector4 &sphere);	// teste si une sphere est dans le frustum xyz = coordonnes de la sphere, w = son rayon
	bool CubeInFrustum(float x,float y,float z,float taille);	// teste si un cube est dans le frustum
	bool CubeInFrustum(CVector4 &cube);	// teste si un cube est dans le frustum xyz = coordonnes du cube, w = sa taille
	bool BoxInFrustum(float left, float right, float top, float bottom, float front, float rear);	// teste si une boite quelconque est dans le frustum

private:
	CVector4 _Frustum[6];	// 6 equations de plan pour chaque plan du champ de vision
};

#endif // __HCFrustum__
