#include "CIndice2.h"
#include "CIndice3.h"

CIndice3::CIndice3(void)	// Constructeur par dfaut
{
	*this = 0;
}

CIndice3::CIndice3(CIndice3 &i)	// Constructeur avec initialisation par CIndice3
{
	*this = i;
}

#ifdef __HCIndice2__
CIndice3::CIndice3(CIndice2 &i,long c)	// Constructeur d'un CIndice3  partir d'un CIndice2 + indice C
{
	this->abc[0] = i.ab[0];
	this->abc[1] = i.ab[1];
	this->abc[2] = c;
}

CIndice3::CIndice3(long c,CIndice2 &i)	// Constructeur d'un CIndice3  partir d'un indice C + CIndice2
{
	this->abc[0] = i.ab[0];
	this->abc[1] = i.ab[1];
	this->abc[2] = c;
}
#endif

CIndice3::CIndice3(long a,long b,long c)	// Constructeur avec initialisation par 3 entres
{
	this->abc[0] = a;
	this->abc[1] = b;
	this->abc[2] = c;
}

CIndice3::~CIndice3(void)	// Destructeur
{
	// Nothind todo
}

void CIndice3::swap(CIndice3 *i)	// Echange les 3 indices A, B et C avec un autre CIndice3
{
	CIndice3 tmp=*this;
	*this=*i;
	*i=tmp;
}

//////////////////////////////
//	Les oprateurs simples	//
//////////////////////////////

void CIndice3::operator = (CIndice3 &i)
{
	this->abc[0] = i.abc[0];
	this->abc[1] = i.abc[1];
	this->abc[2] = i.abc[2];
}

void CIndice3::operator = (long i)
{
	this->abc[0] = i;
	this->abc[1] = i;
	this->abc[2] = i;
}

CIndice3 CIndice3::operator + (CIndice3 &i)
{
	return CIndice3(this->abc[0]+i.abc[0], this->abc[1]+i.abc[1], this->abc[2]+i.abc[2]);
}

CIndice3 CIndice3::operator + (long i)
{
	return CIndice3(this->abc[0]+i, this->abc[1]+i, this->abc[2]+i);
}

CIndice3 CIndice3::operator - (CIndice3 &i)
{
	return CIndice3(this->abc[0]-i.abc[0], this->abc[1]-i.abc[1], this->abc[2]-i.abc[2]);
}

CIndice3 CIndice3::operator - (long i)
{
	return CIndice3(this->abc[0]-i, this->abc[1]-i, this->abc[2]-i);
}

CIndice3 CIndice3::operator * (CIndice3 &i)
{
	return CIndice3(this->abc[0]*i.abc[0], this->abc[1]*i.abc[1], this->abc[2]*i.abc[2]);
}

CIndice3 CIndice3::operator * (long i)
{
	return CIndice3(this->abc[0]*i, this->abc[1]*i, this->abc[2]*i);
}

CIndice3 CIndice3::operator / (CIndice3 &i)
{
	return CIndice3(this->abc[0]/i.abc[0], this->abc[1]/i.abc[1], this->abc[2]/i.abc[2]);
}

CIndice3 CIndice3::operator / (long i)
{
	return CIndice3(this->abc[0]/i, this->abc[1]/i, this->abc[2]/i);
}

//////////////////////////////
//	Les oprateurs floats	//
//////////////////////////////

void CIndice3::operator += (CIndice3 &i)
{
	this->abc[0] += i.abc[0];
	this->abc[1] += i.abc[1];
	this->abc[2] += i.abc[2];
}

void CIndice3::operator += (long i)
{
	this->abc[0] += i;
	this->abc[1] += i;
	this->abc[2] += i;
}

void CIndice3::operator -= (CIndice3 &i)
{
	this->abc[0] -= i.abc[0];
	this->abc[1] -= i.abc[1];
	this->abc[2] -= i.abc[2];
}

void CIndice3::operator -= (long i)
{
	this->abc[0] -= i;
	this->abc[1] -= i;
	this->abc[2] -= i;
}

void CIndice3::operator *= (CIndice3 &i)
{
	this->abc[0] *= i.abc[0];
	this->abc[1] *= i.abc[1];
	this->abc[2] *= i.abc[2];
}

void CIndice3::operator *= (long i)
{
	this->abc[0] *= i;
	this->abc[1] *= i;
	this->abc[2] *= i;
}

void CIndice3::operator /= (CIndice3 &i)
{
	this->abc[0] /= i.abc[0];
	this->abc[1] /= i.abc[1];
	this->abc[2] /= i.abc[2];
}

void CIndice3::operator /= (long i)
{
	this->abc[0] /= i;
	this->abc[1] /= i;
	this->abc[2] /= i;
}

//////////////////////////////
//	Les oprateurs de test	//
//////////////////////////////

bool CIndice3::operator == (CIndice3 &i)
{
	return ((this->abc[0]==i.abc[0])&&(this->abc[1]==i.abc[1])&&(this->abc[2]==i.abc[2]));
}

bool CIndice3::operator != (CIndice3 &i)
{
	return ((this->abc[0]!=i.abc[0])||(this->abc[1]!=i.abc[1])||(this->abc[2]!=i.abc[2]));
}
