#include "CIndice2.h"
#include "CIndice3.h"
#include "CIndice4.h"

CIndice4::CIndice4(void)	// Constructeur par dfaut
{
	*this = 0;
}

CIndice4::CIndice4(CIndice4 &i)	// Constructeur avec initialisation par CIndice4
{
	*this = i;
}

#ifdef __HCIndice2__
CIndice4::CIndice4(CIndice2 &i,long c,long d)	// Constructeur d'un CIndice4  partir d'un CIndice2 + indice C et D
{
	this->abcd[0] = i.ab[0];
	this->abcd[1] = i.ab[1];
	this->abcd[2] = c;
	this->abcd[3] = d;
}
#endif

#ifdef __HCIndice3__
CIndice4::CIndice4(CIndice3 &i,long d)	// Constructeur d'un CIndice4  partir d'un CIndice3 + indice C
{
	this->abcd[0] = i.abc[0];
	this->abcd[1] = i.abc[1];
	this->abcd[2] = i.abc[2];
	this->abcd[3] = d;
}
#endif

CIndice4::CIndice4(long a,long b,long c,long d)	// Constructeur avec initialisation par 4 entres
{
	this->abcd[0] = a;
	this->abcd[1] = b;
	this->abcd[2] = c;
	this->abcd[3] = d;
}

CIndice4::~CIndice4(void)	// Destructeur
{
	// Nothind todo
}

void CIndice4::swap(CIndice4 *i)	// Echange les 4 indices A, B, C et D avec un autre CIndice4
{
	CIndice4 tmp=*this;
	*this=*i;
	*i=tmp;
}

//////////////////////////////
//	Les oprateurs simples	//
//////////////////////////////

void CIndice4::operator = (CIndice4 &i)
{
	this->abcd[0] = i.abcd[0];
	this->abcd[1] = i.abcd[1];
	this->abcd[2] = i.abcd[2];
	this->abcd[3] = i.abcd[3];
}

void CIndice4::operator = (long i)
{
	this->abcd[0] = i;
	this->abcd[1] = i;
	this->abcd[2] = i;
	this->abcd[3] = i;
}

CIndice4 CIndice4::operator + (CIndice4 &i)
{
	return CIndice4(this->abcd[0]+i.abcd[0], this->abcd[1]+i.abcd[1], this->abcd[2]+i.abcd[2], this->abcd[3]+i.abcd[3]);
}

CIndice4 CIndice4::operator + (long i)
{
	return CIndice4(this->abcd[0]+i, this->abcd[1]+i, this->abcd[2]+i, this->abcd[3]+i);
}

CIndice4 CIndice4::operator - (CIndice4 &i)
{
	return CIndice4(this->abcd[0]-i.abcd[0], this->abcd[1]-i.abcd[1], this->abcd[2]-i.abcd[2], this->abcd[3]-i.abcd[3]);
}

CIndice4 CIndice4::operator - (long i)
{
	return CIndice4(this->abcd[0]-i, this->abcd[1]-i, this->abcd[2]-i, this->abcd[3]-i);
}

CIndice4 CIndice4::operator * (CIndice4 &i)
{
	return CIndice4(this->abcd[0]*i.abcd[0], this->abcd[1]*i.abcd[1], this->abcd[2]*i.abcd[2], this->abcd[3]*i.abcd[3]);
}

CIndice4 CIndice4::operator * (long i)
{
	return CIndice4(this->abcd[0]*i, this->abcd[1]*i, this->abcd[2]*i, this->abcd[3]*i);
}

CIndice4 CIndice4::operator / (CIndice4 &i)
{
	return CIndice4(this->abcd[0]/i.abcd[0], this->abcd[1]/i.abcd[1], this->abcd[2]/i.abcd[2], this->abcd[3]/i.abcd[3]);
}

CIndice4 CIndice4::operator / (long i)
{
	return CIndice4(this->abcd[0]/i, this->abcd[1]/i, this->abcd[2]/i, this->abcd[3]/i);
}

//////////////////////////////
//	Les oprateurs floats	//
//////////////////////////////

void CIndice4::operator += (CIndice4 &i)
{
	this->abcd[0] += i.abcd[0];
	this->abcd[1] += i.abcd[1];
	this->abcd[2] += i.abcd[2];
	this->abcd[3] += i.abcd[3];
}

void CIndice4::operator += (long i)
{
	this->abcd[0] += i;
	this->abcd[1] += i;
	this->abcd[2] += i;
	this->abcd[3] += i;
}

void CIndice4::operator -= (CIndice4 &i)
{
	this->abcd[0] -= i.abcd[0];
	this->abcd[1] -= i.abcd[1];
	this->abcd[2] -= i.abcd[2];
	this->abcd[3] -= i.abcd[3];
}

void CIndice4::operator -= (long i)
{
	this->abcd[0] -= i;
	this->abcd[1] -= i;
	this->abcd[2] -= i;
	this->abcd[3] -= i;
}

void CIndice4::operator *= (CIndice4 &i)
{
	this->abcd[0] *= i.abcd[0];
	this->abcd[1] *= i.abcd[1];
	this->abcd[2] *= i.abcd[2];
	this->abcd[3] *= i.abcd[3];
}

void CIndice4::operator *= (long i)
{
	this->abcd[0] *= i;
	this->abcd[1] *= i;
	this->abcd[2] *= i;
	this->abcd[3] *= i;
}

void CIndice4::operator /= (CIndice4 &i)
{
	this->abcd[0] /= i.abcd[0];
	this->abcd[1] /= i.abcd[1];
	this->abcd[2] /= i.abcd[2];
	this->abcd[3] /= i.abcd[3];
}

void CIndice4::operator /= (long i)
{
	this->abcd[0] /= i;
	this->abcd[1] /= i;
	this->abcd[2] /= i;
	this->abcd[3] /= i;
}

//////////////////////////////
//	Les oprateurs de test	//
//////////////////////////////

bool CIndice4::operator == (CIndice4 &i)
{
	return ((this->abcd[0]==i.abcd[0])&&(this->abcd[1]==i.abcd[1])&&(this->abcd[2]==i.abcd[2])&&(this->abcd[3]==i.abcd[3]));
}

bool CIndice4::operator != (CIndice4 &i)
{
	return ((this->abcd[0]!=i.abcd[0])||(this->abcd[1]!=i.abcd[1])||(this->abcd[2]!=i.abcd[2])||(this->abcd[3]!=i.abcd[3]));
}
