#ifndef __HCMaterial__
#define __HCMaterial__

#define __HCMaterial__MAX_TEXTURES	2
#define __HCMaterial__MAX_MATERIALS	128
#define __HCMaterial__NEED_SPACE	32

#include "CVector4.h"
#include "CString.h"
#include "CTexture.h"

typedef struct {
	CString Name;
	CVector4 Ka;	// ambient
	CVector4 Kd;	// diffuse
	CVector4 Ks;	// specular
	CVector4 Ke;	// emission
	float Ns;	// shininess
	unsigned int idTex[__HCMaterial__MAX_TEXTURES];
	unsigned int nbTex;
}SMaterial;

class CMaterial {
public:
	CMaterial(void);	// constructeur par dfaut
	~CMaterial();	// destructeur
	long Create(char *name,CVector4 a,CVector4 d,CVector4 s,CVector4 e,float sh);	// cration  partir de 4 CVector4 + 1 float (pas de texture)
	long Create(char *name,float *all);	// cration  partir d'un tableau de float (pas de texture)
	long Create(SMaterial *strm);	// cration  partir des donnes entres dans une structure
	bool Load(char *filename);	// charge un fichier matrial
	long GetId(char *name);	// retourne l'id du matrial name, 0 si inexistant
	long GetId(CString name);	// retourne l'id du matrial name, 0 si inexistant
	void SetMat(long m);	// fait intervenir le material m dans le rendu
	void Texture(long m,unsigned int t,unsigned int n);	// intgre la texture t dans le matrial m et la dfinie en position n
	bool AddTexture(long m,unsigned int t);	// ajoute la texture t au matrial m et retourne false si pas de place
	void UnTexture(long m);	// retire toutes textures du matrial m
	void UnTexture(long m,unsigned int t);	// retire la texture t du matrial m

private:
	void _AddMaterials(void);	// augmente de __HCMaterial__NEED_SPACE le nombre de nombre de matrials pouvant tre chargs
	long _nbMat;		// nombre de matrials chargs
	long _nbMaxMat;	// nombre maximum de matrials pouvant tre chargs
	long _LastCalled;	// id du dernier matrial appel
	SMaterial *_pMaterial;
};

#endif // __HCMaterial__
