#ifndef incCMatrixH
#define incCMatrixH
#endif

typedef struct
{
	float *m;
}SMatrix;

class CMatrix {
public:
	CMatrix(int x, int y);	// constructeur par dfaut, cre une matrice identit de dimensions x,y
	CMatrix(float *m,int x,int y);	// constructeur  partir d'un tableau de float et des dimensions
	CMatrix(CMatrix4 &m);	// cre une matrice  partir d'une CMatrice4
	~CMatrix();	// destructeur
	void Compute(float *m);	// multiplie la matrice avec une autre matrice stocke dans un tableau de float
	void Compute(CMatrix &m);	// multiplie avec une autre CMatrix
	void Compute(CMatrix4 &m);	// multiplie avec une CMatrix4
	void Inverse(void);	// inverse la matrice
	void Reset(void);	// la matrice devient une matrice identit

	CMatrix operator = (CMatrix &m);
	CMatrix operator + (CMatrix &m);
	CMatrix operator - (CMatrix &m);
	CMatrix operator * (CMatrix &m);
	CMatrix operator * (CMatrix4 &m);
	CMatrix operator / (CMatrix &m);

	void operator += (CMatrix &m);
	void operator -= (CMatrix &m);
	void operator *= (CMatrix &m);
	void operator /= (CMatrix &m);

	bool operator == (CMatrix &m);
	bool operator != (CMatrix &m);
private:
	float *_pmatrix;
	int _x,_y;
};
