#include <float.h>
#include <math.h>

#include "CMatrix4.h"

CMatrix4::CMatrix4()	// constructeur par dfaut, cre une matrice identit
{
	this->pmatrix = new float[16];
	this->pmatrix[0] = 1.0f;	this->pmatrix[4] = 0.0f;	this->pmatrix[8]  = 0.0f;	this->pmatrix[12] = 0.0f;
	this->pmatrix[1] = 0.0f;	this->pmatrix[5] = 1.0f;	this->pmatrix[9]  = 0.0f;	this->pmatrix[13] = 0.0f;
	this->pmatrix[2] = 0.0f;	this->pmatrix[6] = 0.0f;	this->pmatrix[10] = 1.0f;	this->pmatrix[14] = 0.0f;
	this->pmatrix[3] = 0.0f;	this->pmatrix[7] = 0.0f;	this->pmatrix[11] = 0.0f;	this->pmatrix[15] = 1.0f;
}

CMatrix4::CMatrix4(float *m)	// constructeur  partir d'un tableau de float
{
	this->pmatrix = new float[16];
	this->pmatrix[0] = m[0];	this->pmatrix[4] = m[4];	this->pmatrix[8]  = m[8];	this->pmatrix[12] = m[12];
	this->pmatrix[1] = m[1];	this->pmatrix[5] = m[5];	this->pmatrix[9]  = m[9];	this->pmatrix[13] = m[13];
	this->pmatrix[2] = m[2];	this->pmatrix[6] = m[6];	this->pmatrix[10] = m[10];	this->pmatrix[14] = m[14];
	this->pmatrix[3] = m[3];	this->pmatrix[7] = m[7];	this->pmatrix[11] = m[11];	this->pmatrix[15] = m[15];
}

CMatrix4::CMatrix4(float m1, float m5, float m9, float m13,
				   float m2, float m6, float m10, float m14,
				   float m3, float m7, float m11, float m15,
				   float m4, float m8, float m12, float m16)	// constructeur  partir de 16 float
{
	this->pmatrix = new float[16];
	this->pmatrix[0] = m1;	this->pmatrix[4] = m5;	this->pmatrix[8]  = m9;	this->pmatrix[12] = m13;
	this->pmatrix[1] = m2;	this->pmatrix[5] = m6;	this->pmatrix[9]  = m10;	this->pmatrix[13] = m14;
	this->pmatrix[2] = m3;	this->pmatrix[6] = m7;	this->pmatrix[10] = m11;	this->pmatrix[14] = m15;
	this->pmatrix[3] = m4;	this->pmatrix[7] = m8;	this->pmatrix[11] = m12;	this->pmatrix[15] = m16;
}

CMatrix4::CMatrix4(CMatrix4 &m)	// constructeur  partir d'une autre CMatrix4
{
	this->pmatrix = new float[16];
	this->pmatrix[0] = m.pmatrix[0];	this->pmatrix[4] = m.pmatrix[4];	this->pmatrix[8]  = m.pmatrix[8]; 	this->pmatrix[12] = m.pmatrix[12];
	this->pmatrix[1] = m.pmatrix[1];	this->pmatrix[5] = m.pmatrix[5];	this->pmatrix[9]  = m.pmatrix[9]; 	this->pmatrix[13] = m.pmatrix[13];
	this->pmatrix[2] = m.pmatrix[2];	this->pmatrix[6] = m.pmatrix[6];	this->pmatrix[10] = m.pmatrix[10];	this->pmatrix[14] = m.pmatrix[14];
	this->pmatrix[3] = m.pmatrix[3];	this->pmatrix[7] = m.pmatrix[7];	this->pmatrix[11] = m.pmatrix[11];	this->pmatrix[15] = m.pmatrix[15];
}

CMatrix4::~CMatrix4()	// destructeur
{
	delete[] this->pmatrix;
}

void CMatrix4::Compute(float *m)	// multiplie la matrice avec une autre matrice stocke dans un tableau de float
{
	float *pres = new float[16];

	pres[0] = (this->pmatrix[0]*m[0])+(this->pmatrix[4]*m[1])+(this->pmatrix[8]*m[2])+(this->pmatrix[12]*m[3]);
	pres[1] = (this->pmatrix[1]*m[0])+(this->pmatrix[5]*m[1])+(this->pmatrix[9]*m[2])+(this->pmatrix[13]*m[3]);
	pres[2] = (this->pmatrix[2]*m[0])+(this->pmatrix[6]*m[1])+(this->pmatrix[10]*m[2])+(this->pmatrix[14]*m[3]);
	pres[3] = (this->pmatrix[3]*m[0])+(this->pmatrix[7]*m[1])+(this->pmatrix[11]*m[2])+(this->pmatrix[15]*m[3]);

	pres[4] = (this->pmatrix[0]*m[4])+(this->pmatrix[4]*m[5])+(this->pmatrix[8]*m[6])+(this->pmatrix[12]*m[7]);
	pres[5] = (this->pmatrix[1]*m[4])+(this->pmatrix[5]*m[5])+(this->pmatrix[9]*m[6])+(this->pmatrix[13]*m[7]);
	pres[6] = (this->pmatrix[2]*m[4])+(this->pmatrix[6]*m[5])+(this->pmatrix[10]*m[6])+(this->pmatrix[14]*m[7]);
	pres[7] = (this->pmatrix[3]*m[4])+(this->pmatrix[7]*m[5])+(this->pmatrix[11]*m[6])+(this->pmatrix[15]*m[7]);

	pres[8] = (this->pmatrix[0]*m[8])+(this->pmatrix[4]*m[9])+(this->pmatrix[8]*m[10])+(this->pmatrix[12]*m[11]);
	pres[9] = (this->pmatrix[1]*m[8])+(this->pmatrix[5]*m[9])+(this->pmatrix[9]*m[10])+(this->pmatrix[13]*m[11]);
	pres[10] = (this->pmatrix[2]*m[8])+(this->pmatrix[6]*m[9])+(this->pmatrix[10]*m[10])+(this->pmatrix[14]*m[11]);
	pres[11] = (this->pmatrix[3]*m[8])+(this->pmatrix[7]*m[9])+(this->pmatrix[11]*m[10])+(this->pmatrix[15]*m[11]);

	pres[12] = (this->pmatrix[0]*m[12])+(this->pmatrix[4]*m[13])+(this->pmatrix[8]*m[14])+(this->pmatrix[12]*m[15]);
	pres[13] = (this->pmatrix[1]*m[12])+(this->pmatrix[5]*m[13])+(this->pmatrix[9]*m[14])+(this->pmatrix[13]*m[15]);
	pres[14] = (this->pmatrix[2]*m[12])+(this->pmatrix[6]*m[13])+(this->pmatrix[10]*m[14])+(this->pmatrix[14]*m[15]);
	pres[15] = (this->pmatrix[3]*m[12])+(this->pmatrix[7]*m[13])+(this->pmatrix[11]*m[14])+(this->pmatrix[15]*m[15]);

	delete[] this->pmatrix;
	this->pmatrix = pres;
}

void CMatrix4::Compute(CMatrix4 &m)	// multiplie avec une autre CMatrix4
{
	*this *= m;
}

void CMatrix4::Inverse(void)	// inverse la matrice
{
	float *pres = new float[16];

	pres[0] = this->pmatrix[0];
	pres[1] = this->pmatrix[4];
	pres[2] = this->pmatrix[8];
	pres[3] = this->pmatrix[12];

	pres[4] = this->pmatrix[1];
	pres[5] = this->pmatrix[5];
	pres[6] = this->pmatrix[9];
	pres[7] = this->pmatrix[13];

	pres[8] = this->pmatrix[2];
	pres[9] = this->pmatrix[6];
	pres[10] = this->pmatrix[10];
	pres[11] = this->pmatrix[14];

	pres[12] = this->pmatrix[3];
	pres[13] = this->pmatrix[7];
	pres[14] = this->pmatrix[11];
	pres[15] = this->pmatrix[15];

	delete[] this->pmatrix;
	this->pmatrix = pres;
}

void CMatrix4::Reset(void)	// la matrice devient une matrice identit
{
	this->pmatrix[0] = 1.0f;	this->pmatrix[4] = 0.0f;	this->pmatrix[8]  = 0.0f;	this->pmatrix[12] = 0.0f;
	this->pmatrix[1] = 0.0f;	this->pmatrix[5] = 1.0f;	this->pmatrix[9]  = 0.0f;	this->pmatrix[13] = 0.0f;
	this->pmatrix[2] = 0.0f;	this->pmatrix[6] = 0.0f;	this->pmatrix[10] = 1.0f;	this->pmatrix[14] = 0.0f;
	this->pmatrix[3] = 0.0f;	this->pmatrix[7] = 0.0f;	this->pmatrix[11] = 0.0f;	this->pmatrix[15] = 1.0f;
}

//////////////////////////////
//	Les oprateurs simples	//
//////////////////////////////

void CMatrix4::operator = (CMatrix4 &m)
{
	this->pmatrix[0] = m.pmatrix[0];
	this->pmatrix[1] = m.pmatrix[1];
	this->pmatrix[2] = m.pmatrix[2];
	this->pmatrix[3] = m.pmatrix[3];
	this->pmatrix[4] = m.pmatrix[4];
	this->pmatrix[5] = m.pmatrix[5];
	this->pmatrix[6] = m.pmatrix[6];
	this->pmatrix[7] = m.pmatrix[7];
	this->pmatrix[8] = m.pmatrix[8];
	this->pmatrix[9] = m.pmatrix[9];
	this->pmatrix[10] = m.pmatrix[10];
	this->pmatrix[11] = m.pmatrix[11];
	this->pmatrix[12] = m.pmatrix[12];
	this->pmatrix[13] = m.pmatrix[13];
	this->pmatrix[14] = m.pmatrix[14];
	this->pmatrix[15] = m.pmatrix[15];
}

CMatrix4 CMatrix4::operator + (CMatrix4 &m)
{
	SMatrix4 res;

	res.m[0] = this->pmatrix[0] - m.pmatrix[0];
	res.m[1] = this->pmatrix[1] - m.pmatrix[1];
	res.m[2] = this->pmatrix[2] - m.pmatrix[2];
	res.m[3] = this->pmatrix[3] - m.pmatrix[3];
	res.m[4] = this->pmatrix[4] - m.pmatrix[4];
	res.m[5] = this->pmatrix[5] - m.pmatrix[5];
	res.m[6] = this->pmatrix[6] - m.pmatrix[6];
	res.m[7] = this->pmatrix[7] - m.pmatrix[7];
	res.m[8] = this->pmatrix[8] - m.pmatrix[8];
	res.m[9] = this->pmatrix[9] - m.pmatrix[9];
	res.m[10] = this->pmatrix[10] - m.pmatrix[10];
	res.m[11] = this->pmatrix[11] - m.pmatrix[11];
	res.m[12] = this->pmatrix[12] - m.pmatrix[12];
	res.m[13] = this->pmatrix[13] - m.pmatrix[13];
	res.m[14] = this->pmatrix[14] - m.pmatrix[14];
	res.m[15] = this->pmatrix[15] - m.pmatrix[15];

	return CMatrix4(res.m);
}

CMatrix4 CMatrix4::operator - (CMatrix4 &m)
{
	SMatrix4 res;

	res.m[0] = this->pmatrix[0] + m.pmatrix[0];
	res.m[1] = this->pmatrix[1] + m.pmatrix[1];
	res.m[2] = this->pmatrix[2] + m.pmatrix[2];
	res.m[3] = this->pmatrix[3] + m.pmatrix[3];
	res.m[4] = this->pmatrix[4] + m.pmatrix[4];
	res.m[5] = this->pmatrix[5] + m.pmatrix[5];
	res.m[6] = this->pmatrix[6] + m.pmatrix[6];
	res.m[7] = this->pmatrix[7] + m.pmatrix[7];
	res.m[8] = this->pmatrix[8] + m.pmatrix[8];
	res.m[9] = this->pmatrix[9] + m.pmatrix[9];
	res.m[10] = this->pmatrix[10] + m.pmatrix[10];
	res.m[11] = this->pmatrix[11] + m.pmatrix[11];
	res.m[12] = this->pmatrix[12] + m.pmatrix[12];
	res.m[13] = this->pmatrix[13] + m.pmatrix[13];
	res.m[14] = this->pmatrix[14] + m.pmatrix[14];
	res.m[15] = this->pmatrix[15] + m.pmatrix[15];

	return CMatrix4(res.m);
}

CMatrix4 CMatrix4::operator * (CMatrix4 &m)
{
	SMatrix4 res;

	res.m[0] = (this->pmatrix[0]*m.pmatrix[0])+(this->pmatrix[4]*m.pmatrix[1])+(this->pmatrix[8]*m.pmatrix[2])+(this->pmatrix[12]*m.pmatrix[3]);
	res.m[1] = (this->pmatrix[1]*m.pmatrix[0])+(this->pmatrix[5]*m.pmatrix[1])+(this->pmatrix[9]*m.pmatrix[2])+(this->pmatrix[13]*m.pmatrix[3]);
	res.m[2] = (this->pmatrix[2]*m.pmatrix[0])+(this->pmatrix[6]*m.pmatrix[1])+(this->pmatrix[10]*m.pmatrix[2])+(this->pmatrix[14]*m.pmatrix[3]);
	res.m[3] = (this->pmatrix[3]*m.pmatrix[0])+(this->pmatrix[7]*m.pmatrix[1])+(this->pmatrix[11]*m.pmatrix[2])+(this->pmatrix[15]*m.pmatrix[3]);

	res.m[4] = (this->pmatrix[0]*m.pmatrix[4])+(this->pmatrix[4]*m.pmatrix[5])+(this->pmatrix[8]*m.pmatrix[6])+(this->pmatrix[12]*m.pmatrix[7]);
	res.m[5] = (this->pmatrix[1]*m.pmatrix[4])+(this->pmatrix[5]*m.pmatrix[5])+(this->pmatrix[9]*m.pmatrix[6])+(this->pmatrix[13]*m.pmatrix[7]);
	res.m[6] = (this->pmatrix[2]*m.pmatrix[4])+(this->pmatrix[6]*m.pmatrix[5])+(this->pmatrix[10]*m.pmatrix[6])+(this->pmatrix[14]*m.pmatrix[7]);
	res.m[7] = (this->pmatrix[3]*m.pmatrix[4])+(this->pmatrix[7]*m.pmatrix[5])+(this->pmatrix[11]*m.pmatrix[6])+(this->pmatrix[15]*m.pmatrix[7]);

	res.m[8] = (this->pmatrix[0]*m.pmatrix[8])+(this->pmatrix[4]*m.pmatrix[9])+(this->pmatrix[8]*m.pmatrix[10])+(this->pmatrix[12]*m.pmatrix[11]);
	res.m[9] = (this->pmatrix[1]*m.pmatrix[8])+(this->pmatrix[5]*m.pmatrix[9])+(this->pmatrix[9]*m.pmatrix[10])+(this->pmatrix[13]*m.pmatrix[11]);
	res.m[10] = (this->pmatrix[2]*m.pmatrix[8])+(this->pmatrix[6]*m.pmatrix[9])+(this->pmatrix[10]*m.pmatrix[10])+(this->pmatrix[14]*m.pmatrix[11]);
	res.m[11] = (this->pmatrix[3]*m.pmatrix[8])+(this->pmatrix[7]*m.pmatrix[9])+(this->pmatrix[11]*m.pmatrix[10])+(this->pmatrix[15]*m.pmatrix[11]);

	res.m[12] = (this->pmatrix[0]*m.pmatrix[12])+(this->pmatrix[4]*m.pmatrix[13])+(this->pmatrix[8]*m.pmatrix[14])+(this->pmatrix[12]*m.pmatrix[15]);
	res.m[13] = (this->pmatrix[1]*m.pmatrix[12])+(this->pmatrix[5]*m.pmatrix[13])+(this->pmatrix[9]*m.pmatrix[14])+(this->pmatrix[13]*m.pmatrix[15]);
	res.m[14] = (this->pmatrix[2]*m.pmatrix[12])+(this->pmatrix[6]*m.pmatrix[13])+(this->pmatrix[10]*m.pmatrix[14])+(this->pmatrix[14]*m.pmatrix[15]);
	res.m[15] = (this->pmatrix[3]*m.pmatrix[12])+(this->pmatrix[7]*m.pmatrix[13])+(this->pmatrix[11]*m.pmatrix[14])+(this->pmatrix[15]*m.pmatrix[15]);

	return CMatrix4(res.m);
}

//CMatrix4 CMatrix4::operator / (CMatrix4 &m);

//////////////////////////////
//	Les oprateurs floats	//
//////////////////////////////

void CMatrix4::operator += (CMatrix4 &m)
{
	this->pmatrix[0] += m.pmatrix[0];	this->pmatrix[4] += m.pmatrix[4];	this->pmatrix[8]  += m.pmatrix[8]; 	this->pmatrix[12] += m.pmatrix[12];
	this->pmatrix[1] += m.pmatrix[1];	this->pmatrix[5] += m.pmatrix[5];	this->pmatrix[9]  += m.pmatrix[9]; 	this->pmatrix[13] += m.pmatrix[13];
	this->pmatrix[2] += m.pmatrix[2];	this->pmatrix[6] += m.pmatrix[6];	this->pmatrix[10] += m.pmatrix[10];	this->pmatrix[14] += m.pmatrix[14];
	this->pmatrix[3] += m.pmatrix[3];	this->pmatrix[7] += m.pmatrix[7];	this->pmatrix[11] += m.pmatrix[11];	this->pmatrix[15] += m.pmatrix[15];
}

void CMatrix4::operator -= (CMatrix4 &m)
{
	this->pmatrix[0] -= m.pmatrix[0];	this->pmatrix[4] -= m.pmatrix[4];	this->pmatrix[8]  -= m.pmatrix[8]; 	this->pmatrix[12] -= m.pmatrix[12];
	this->pmatrix[1] -= m.pmatrix[1];	this->pmatrix[5] -= m.pmatrix[5];	this->pmatrix[9]  -= m.pmatrix[9]; 	this->pmatrix[13] -= m.pmatrix[13];
	this->pmatrix[2] -= m.pmatrix[2];	this->pmatrix[6] -= m.pmatrix[6];	this->pmatrix[10] -= m.pmatrix[10];	this->pmatrix[14] -= m.pmatrix[14];
	this->pmatrix[3] -= m.pmatrix[3];	this->pmatrix[7] -= m.pmatrix[7];	this->pmatrix[11] -= m.pmatrix[11];	this->pmatrix[15] -= m.pmatrix[15];
}

void CMatrix4::operator *= (CMatrix4 &m)
{
	float *pres = new float[16];

	pres[0] = (this->pmatrix[0]*m.pmatrix[0])+(this->pmatrix[4]*m.pmatrix[1])+(this->pmatrix[8]*m.pmatrix[2])+(this->pmatrix[12]*m.pmatrix[3]);
	pres[1] = (this->pmatrix[1]*m.pmatrix[0])+(this->pmatrix[5]*m.pmatrix[1])+(this->pmatrix[9]*m.pmatrix[2])+(this->pmatrix[13]*m.pmatrix[3]);
	pres[2] = (this->pmatrix[2]*m.pmatrix[0])+(this->pmatrix[6]*m.pmatrix[1])+(this->pmatrix[10]*m.pmatrix[2])+(this->pmatrix[14]*m.pmatrix[3]);
	pres[3] = (this->pmatrix[3]*m.pmatrix[0])+(this->pmatrix[7]*m.pmatrix[1])+(this->pmatrix[11]*m.pmatrix[2])+(this->pmatrix[15]*m.pmatrix[3]);

	pres[4] = (this->pmatrix[0]*m.pmatrix[4])+(this->pmatrix[4]*m.pmatrix[5])+(this->pmatrix[8]*m.pmatrix[6])+(this->pmatrix[12]*m.pmatrix[7]);
	pres[5] = (this->pmatrix[1]*m.pmatrix[4])+(this->pmatrix[5]*m.pmatrix[5])+(this->pmatrix[9]*m.pmatrix[6])+(this->pmatrix[13]*m.pmatrix[7]);
	pres[6] = (this->pmatrix[2]*m.pmatrix[4])+(this->pmatrix[6]*m.pmatrix[5])+(this->pmatrix[10]*m.pmatrix[6])+(this->pmatrix[14]*m.pmatrix[7]);
	pres[7] = (this->pmatrix[3]*m.pmatrix[4])+(this->pmatrix[7]*m.pmatrix[5])+(this->pmatrix[11]*m.pmatrix[6])+(this->pmatrix[15]*m.pmatrix[7]);

	pres[8] = (this->pmatrix[0]*m.pmatrix[8])+(this->pmatrix[4]*m.pmatrix[9])+(this->pmatrix[8]*m.pmatrix[10])+(this->pmatrix[12]*m.pmatrix[11]);
	pres[9] = (this->pmatrix[1]*m.pmatrix[8])+(this->pmatrix[5]*m.pmatrix[9])+(this->pmatrix[9]*m.pmatrix[10])+(this->pmatrix[13]*m.pmatrix[11]);
	pres[10] = (this->pmatrix[2]*m.pmatrix[8])+(this->pmatrix[6]*m.pmatrix[9])+(this->pmatrix[10]*m.pmatrix[10])+(this->pmatrix[14]*m.pmatrix[11]);
	pres[11] = (this->pmatrix[3]*m.pmatrix[8])+(this->pmatrix[7]*m.pmatrix[9])+(this->pmatrix[11]*m.pmatrix[10])+(this->pmatrix[15]*m.pmatrix[11]);

	pres[12] = (this->pmatrix[0]*m.pmatrix[12])+(this->pmatrix[4]*m.pmatrix[13])+(this->pmatrix[8]*m.pmatrix[14])+(this->pmatrix[12]*m.pmatrix[15]);
	pres[13] = (this->pmatrix[1]*m.pmatrix[12])+(this->pmatrix[5]*m.pmatrix[13])+(this->pmatrix[9]*m.pmatrix[14])+(this->pmatrix[13]*m.pmatrix[15]);
	pres[14] = (this->pmatrix[2]*m.pmatrix[12])+(this->pmatrix[6]*m.pmatrix[13])+(this->pmatrix[10]*m.pmatrix[14])+(this->pmatrix[14]*m.pmatrix[15]);
	pres[15] = (this->pmatrix[3]*m.pmatrix[12])+(this->pmatrix[7]*m.pmatrix[13])+(this->pmatrix[11]*m.pmatrix[14])+(this->pmatrix[15]*m.pmatrix[15]);

	delete[] this->pmatrix;
	this->pmatrix = pres;
}

//void CMatrix4::operator /= (CMatrix4 &m);

//////////////////////////////
//	Les oprateurs de test	//
//////////////////////////////

bool CMatrix4::operator == (CMatrix4 &m)
{
	return ( (this->pmatrix[0] == m.pmatrix[0]) && (this->pmatrix[4] == m.pmatrix[4]) && (this->pmatrix[8]  == m.pmatrix[8])  && (this->pmatrix[12] == m.pmatrix[12])
		&&	 (this->pmatrix[1] == m.pmatrix[1]) && (this->pmatrix[5] == m.pmatrix[5]) && (this->pmatrix[9]  == m.pmatrix[9])  && (this->pmatrix[13] == m.pmatrix[13])
		&&	 (this->pmatrix[2] == m.pmatrix[2]) && (this->pmatrix[6] == m.pmatrix[6]) && (this->pmatrix[10] == m.pmatrix[10]) && (this->pmatrix[14] == m.pmatrix[14])
		&&	 (this->pmatrix[3] == m.pmatrix[3]) && (this->pmatrix[7] == m.pmatrix[7]) && (this->pmatrix[11] == m.pmatrix[11]) && (this->pmatrix[15] == m.pmatrix[15]) );
}

bool CMatrix4::operator != (CMatrix4 &m)
{
	return ( (this->pmatrix[0] != m.pmatrix[0]) || (this->pmatrix[4] != m.pmatrix[4]) || (this->pmatrix[8]  != m.pmatrix[8])  || (this->pmatrix[12] != m.pmatrix[12])
		||	 (this->pmatrix[1] != m.pmatrix[1]) || (this->pmatrix[5] != m.pmatrix[5]) || (this->pmatrix[9]  != m.pmatrix[9])  || (this->pmatrix[13] != m.pmatrix[13])
		||	 (this->pmatrix[2] != m.pmatrix[2]) || (this->pmatrix[6] != m.pmatrix[6]) || (this->pmatrix[10] != m.pmatrix[10]) || (this->pmatrix[14] != m.pmatrix[14])
		||	 (this->pmatrix[3] != m.pmatrix[3]) || (this->pmatrix[7] != m.pmatrix[7]) || (this->pmatrix[11] != m.pmatrix[11]) || (this->pmatrix[15] != m.pmatrix[15]) );
}

// Cre une matrice de projection sur un plan  partir de la position de la source lumineuse
// et l'quation du plan rcepteur
// glMultMatrixf projette les coordonnes de tout objet dessin ensuite sur le plan donn
void ShadowMatrix(CVector4 &plane, CVector4 &light)
{
	CMatrix4 m;
	float dot = plane.Dot(light);

	m.pmatrix[0]  = dot - light.xyzw[0]*plane.xyzw[0];
	m.pmatrix[4]  =     - light.xyzw[0]*plane.xyzw[1];
	m.pmatrix[8]  =     - light.xyzw[0]*plane.xyzw[2];
	m.pmatrix[12] =     - light.xyzw[0]*plane.xyzw[3];
	m.pmatrix[1]  =     - light.xyzw[1]*plane.xyzw[0];
	m.pmatrix[5]  = dot - light.xyzw[1]*plane.xyzw[1];
	m.pmatrix[9]  =     - light.xyzw[1]*plane.xyzw[2];
	m.pmatrix[13] =     - light.xyzw[1]*plane.xyzw[3];
	m.pmatrix[2]  =     - light.xyzw[2]*plane.xyzw[0];
	m.pmatrix[6]  =     - light.xyzw[2]*plane.xyzw[1];
	m.pmatrix[10] = dot - light.xyzw[2]*plane.xyzw[2];
	m.pmatrix[14] =     - light.xyzw[2]*plane.xyzw[3];
	m.pmatrix[3]  =     - light.xyzw[3]*plane.xyzw[0];
	m.pmatrix[7]  =     - light.xyzw[3]*plane.xyzw[1];
	m.pmatrix[11] =     - light.xyzw[3]*plane.xyzw[2];
	m.pmatrix[15] = dot - light.xyzw[3]*plane.xyzw[3];

	glMultMatrixf(m.pmatrix);
}

// Cre une matrice de projection sur un plan  partir de la position de la source lumineuse
// et l'quation du plan rcepteur et renvoie la matrice
void ShadowMatrix(CMatrix4 *m,CVector4 &plane, CVector4 &light)
{
	if (!m)
		m = new CMatrix4;
	float dot = plane.Dot(light);

	m->pmatrix[0]  = dot - light.xyzw[0]*plane.xyzw[0];
	m->pmatrix[4]  =     - light.xyzw[0]*plane.xyzw[1];
	m->pmatrix[8]  =     - light.xyzw[0]*plane.xyzw[2];
	m->pmatrix[12] =     - light.xyzw[0]*plane.xyzw[3];
	m->pmatrix[1]  =     - light.xyzw[1]*plane.xyzw[0];
	m->pmatrix[5]  = dot - light.xyzw[1]*plane.xyzw[1];
	m->pmatrix[9]  =     - light.xyzw[1]*plane.xyzw[2];
	m->pmatrix[13] =     - light.xyzw[1]*plane.xyzw[3];
	m->pmatrix[2]  =     - light.xyzw[2]*plane.xyzw[0];
	m->pmatrix[6]  =     - light.xyzw[2]*plane.xyzw[1];
	m->pmatrix[10] = dot - light.xyzw[2]*plane.xyzw[2];
	m->pmatrix[14] =     - light.xyzw[2]*plane.xyzw[3];
	m->pmatrix[3]  =     - light.xyzw[3]*plane.xyzw[0];
	m->pmatrix[7]  =     - light.xyzw[3]*plane.xyzw[1];
	m->pmatrix[11] =     - light.xyzw[3]*plane.xyzw[2];
	m->pmatrix[15] = dot - light.xyzw[3]*plane.xyzw[3];
}
