#ifndef __HCMatrix4__
#define __HCMatrix4__

#include "windows.h"

#include "gl/gl.h"

#include "CVector4.h"

typedef struct
{
	float m[16];
}SMatrix4;

class CMatrix4 {
public:
	float *pmatrix;

	CMatrix4(void);	// constructeur par dfaut, cre une matrice identit
	CMatrix4(float *m);	// constructeur  partir d'un tableau de float
	CMatrix4(float m1, float m5, float m9, float m13,
				   float m2, float m6, float m10, float m14,
				   float m3, float m7, float m11, float m15,
				   float m4, float m8, float m12, float m16);	// constructeur  partir de 16 float
	CMatrix4(CMatrix4 &m);	// constructeur  partir d'une autre CMatrix4
	~CMatrix4(void);	// destructeur
	void Compute(float *m);	// multiplie la matrice avec une autre matrice stocke dans un tableau de float
	void Compute(CMatrix4 &m);	// multiplie avec une autre CMatrix4
	void Inverse(void);	// inverse la matrice
/*		Fonctions juges inutiles
	void RotateX(float angle);	// rotation selon x
	void RotateY(float angle);	// rotation selon y
	void RotateZ(float angle);	// rotation selon z
	void Rotate(float x, float y,float z);	// rotation sur x,y et z
	void Rotate(CVector2 &v);	// rotation via un CVector2 (x,y)
	void Rotate(CVector3 &v);	// rotation via un CVector3 (x,y,z)
*/	void Reset(void);	// la matrice devient une matrice identit

	void operator = (CMatrix4 &m);
	CMatrix4 operator + (CMatrix4 &m);
	CMatrix4 operator - (CMatrix4 &m);
	CMatrix4 operator * (CMatrix4 &m);
	CMatrix4 operator / (CMatrix4 &m);

	void operator += (CMatrix4 &m);
	void operator -= (CMatrix4 &m);
	void operator *= (CMatrix4 &m);
	void operator /= (CMatrix4 &m);

	bool operator == (CMatrix4 &m);
	bool operator != (CMatrix4 &m);

	float &operator[](unsigned int index){ return *(((float *) pmatrix) + index); }
};

// Cre une matrice de projection sur un plan  partir de la position de la source lumineuse
// et l'quation du plan rcepteur
// glMultMatrixf projette les coordonnes de tout objet dessin ensuite sur le plan donn
void ShadowMatrix(CVector4 &plane, CVector4 &light);

// Cre une matrice de projection sur un plan  partir de la position de la source lumineuse
// et l'quation du plan rcepteur et renvoie la matrice
void ShadowMatrix(CMatrix4 *m,CVector4 &plane, CVector4 &light);

#endif // __HCMatrix4__
