#include <windows.h>
#include <stdio.h>

#include <gl/gl.h>

#include "CObjet3D.h"
#include "ReadLine.h"
#include "CMaterial.h"

#define PVERTEX1 this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz
#define VERTEX1X this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz[0]
#define VERTEX1Y this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz[1]
#define VERTEX1Z this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz[2]
#define VERTEX2X this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[1]].xyz[0]
#define VERTEX2Y this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[1]].xyz[1]
#define VERTEX2Z this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[1]].xyz[2]
#define VERTEX3X this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[2]].xyz[0]
#define VERTEX3Y this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[2]].xyz[1]
#define VERTEX3Z this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[2]].xyz[2]
#define PNEIGHBOUR this->_pGroupes[g].pFaceShadow[f].Neightbour
#define NEIGHBOUR1 this->_pGroupes[g].pFaceShadow[f].Neightbour.abc[0]
#define NEIGHBOUR2 this->_pGroupes[g].pFaceShadow[f].Neightbour.abc[1]
#define NEIGHBOUR3 this->_pGroupes[g].pFaceShadow[f].Neightbour.abc[2]

extern CMaterial *materials;
extern CTexture *textures;

CObjet3D::CObjet3D()	// Cre un dummy
{
	this->_nbVertices	= 0;
	this->_nbNormals	= 0;
	this->_nbTexCoords	= 0;
	this->_nbGroupes	= 0;
	this->_pDisplayLists = NULL;
	this->_pVertices	= NULL;
	this->_pNormals		= NULL;
	this->_pTexCoords	= NULL;
	this->_pGroupes		= NULL;

	this->_Dummy();
//	this->_DummyMulticolor();
	this->InitShadowing();
}

CObjet3D::CObjet3D(CObjet3D &o)	// Cre un objet 3D  partir d'un autre objet (copie)
{}

CObjet3D::CObjet3D(char *filename)	// Cre un objet 3D en chargeant un fichier sur le disque
{
	FILE *fp = fopen(filename,"rb");

	this->_nbVertices	= 0;
	this->_nbNormals	= 0;
	this->_nbTexCoords	= 0;
	this->_nbGroupes	= 0;
	this->_pDisplayLists = NULL;
	this->_pVertices	= NULL;
	this->_pNormals		= NULL;
	this->_pTexCoords	= NULL;
	this->_pGroupes		= NULL;

	if (fp)
	{
		if (!this->_LoadOBJ(fp))
			this->_Dummy();
		else
			this->_PurifyObject();
		fclose(fp);
	}
	else
	{
		this->_Dummy();
	}
	this->InitShadowing();
}

CObjet3D::CObjet3D(CObjet3D &o,int g)	// Cre un objet 3D  partir d'un groupe d'un autre objet
{}

CObjet3D::~CObjet3D()	// Destructeur
{
	this->_Destroy();
}

void CObjet3D::Draw()	// Affiche l'objet en brut
{
	for (long g=0;g<this->_nbGroupes;g++)
	{
		materials->SetMat(this->_pGroupes[g].MaterialId);
		glBegin(GL_TRIANGLES);
		for (long i=0;i<this->_pGroupes[g].nbFaces;i++)
		{
			glNormal3fv(this->_pNormals[this->_pGroupes[g].pFaces[i].Normal.abc[0]].xyz);
			glTexCoord2fv(this->_pTexCoords[this->_pGroupes[g].pFaces[i].TexCoord.abc[0]].xy);
			glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz);
			glNormal3fv(this->_pNormals[this->_pGroupes[g].pFaces[i].Normal.abc[1]].xyz);
			glTexCoord2fv(this->_pTexCoords[this->_pGroupes[g].pFaces[i].TexCoord.abc[1]].xy);
			glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[1]].xyz);
			glNormal3fv(this->_pNormals[this->_pGroupes[g].pFaces[i].Normal.abc[2]].xyz);
			glTexCoord2fv(this->_pTexCoords[this->_pGroupes[g].pFaces[i].TexCoord.abc[2]].xy);
			glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[2]].xyz);
		}
		glEnd();
	}
}

void CObjet3D::Draw(long g)	// Affiche le groupe de l'objet en brut
{
	if (g<=this->_nbGroupes)
		return;
	
	materials->SetMat(this->_pGroupes[g].MaterialId);
	for (long i=0;i<this->_pGroupes[g].nbFaces;i++)
	{
		glNormal3fv(this->_pNormals[this->_pGroupes[g].pFaces[i].Normal.abc[0]].xyz);
		glTexCoord2fv(this->_pTexCoords[this->_pGroupes[g].pFaces[i].TexCoord.abc[0]].xy);
		glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz);
		glNormal3fv(this->_pNormals[this->_pGroupes[g].pFaces[i].Normal.abc[1]].xyz);
		glTexCoord2fv(this->_pTexCoords[this->_pGroupes[g].pFaces[i].TexCoord.abc[1]].xy);
		glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[1]].xyz);
		glNormal3fv(this->_pNormals[this->_pGroupes[g].pFaces[i].Normal.abc[2]].xyz);
		glTexCoord2fv(this->_pTexCoords[this->_pGroupes[g].pFaces[i].TexCoord.abc[2]].xy);
		glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[2]].xyz);
	}
}

void CObjet3D::DrawSimple()	// Affiche l'objet en brut sans texture ni eclairage
{
	glBegin(GL_TRIANGLES);
	for (long g=0;g<this->_nbGroupes;g++)
	{
		for (long i=0;i<this->_pGroupes[g].nbFaces;i++)
		{
			glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[0]].xyz);
			glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[1]].xyz);
			glVertex3fv(this->_pVertices[this->_pGroupes[g].pFaces[i].Vertex.abc[2]].xyz);
		}
	}
	glEnd();
}

void CObjet3D::DrawSilhouette(CVector3 &source)	// dessine la silhouette de l'objet vue depuis le point source
{
	SVolume3D *Sil;

	glBegin(GL_LINES);
	for (long g = 0; g < this->_nbGroupes ; g++)
	{
		Sil = this->_Silhouette(g,source);
		for (long i=0; i < Sil->nbEdges ;i++)
		{
			glVertex3fv(Sil->Edges[i].v[0].xyz);
			glVertex3fv(Sil->Edges[i].v[1].xyz);
		}
		delete[] Sil->Edges;
		delete Sil;
	}
	glEnd();
}

void extendVolume(CVector3 *v, int localLight, CVector3 lightPosition, float extendDistance)
{
	CVector3 extendedVertex, extendDirection;

	glBegin(GL_QUADS);
	// If light source is local (positional)...
	if (localLight)
	{
		glVertex3fv(v[0].xyz);
		// Compute per-vertex direction from vertex away from the light source.
		extendDirection = v[0] - lightPosition;
		// Compute extended vertex.
		extendedVertex = v[0] + extendDirection * extendDistance;
		glVertex3fv(extendedVertex.xyz);
		// Compute per-vertex direction from vertex away from the light source.
		extendDirection = v[1] - lightPosition;
		// Compute extended vertex.
		extendedVertex = v[1] + extendDirection * extendDistance;
		glVertex3fv(extendedVertex.xyz);
		glVertex3fv(v[1].xyz);
	}
	else
	{
		// otherwise, light source is infinite (directional)...
		// compute direction opposite from light source direction.
		extendDirection -= lightPosition;

		glVertex3fv(v[0].xyz);
		// Compute extended vertex.
		extendedVertex = v[0] + extendDirection * extendDistance;
		glVertex3fv(extendedVertex.xyz);
		// Compute extended vertex.
		extendedVertex = v[1] + extendDirection * extendDistance;
		glVertex3fv(extendedVertex.xyz);
		glVertex3fv(v[1].xyz);
	}
	glEnd();
}

void CObjet3D::DrawShadowVolume(CVector3 &source)	// dessine le volume d'ombre de l'objet gnr par le point source
{
	SVolume3D *Sil;

	for (long g = 0; g < this->_nbGroupes ; g++) // pour chaque groupe de l'objet
	{
		Sil = this->_Silhouette(g,source); // gnre la silhouette
		for (long i=0; i < Sil->nbEdges ;i++) // pour chaque arrte de la silhouette
			extendVolume(Sil->Edges[i].v,0,source,10.0f); // cre un polygone en projetant la silhouette par rapport  la position de la lumire
		delete[] Sil->Edges; // supprime les arrtes de la silhouette pour librer la mmoire
		delete Sil; // supprime la silhouette
	}
}

void CObjet3D::DrawLists()	// Affiche l'objet depuis sa display list
{
	if (this->_pDisplayLists)
		for (long i=0;i<this->_nbGroupes;i++)
			glCallList(this->_pDisplayLists[i]);
}

void CObjet3D::DrawList(long g)	// Affiche le groupe de l'objet depuis sa display list
{
	glCallList(this->_pDisplayLists[g]);
}

void CObjet3D::GenereLists()	// Gnre ou recre la display list de tous les groupes de l'objet
{
	if (!this->_pDisplayLists)
	{
		this->_pDisplayLists = new unsigned int[this->_nbGroupes];
		this->_pDisplayLists[0] = glGenLists(this->_nbGroupes);
		for (long i=1;i<this->_nbGroupes;i++)
			this->_pDisplayLists[i]=this->_pDisplayLists[i-1]+1;
	}

	for (long i=0;i<this->_nbGroupes;i++)
	{
		glNewList(this->_pDisplayLists[i],GL_COMPILE);
		this->Draw();
		glEndList();
	}
}

void CObjet3D::RegenList(long g)	// Recree la display list d'un groupe
{
	if (!this->_pDisplayLists)
		return;

	glNewList(this->_pDisplayLists[g],GL_COMPILE);
//	glBegin(GL_TRIANGLES);
	this->Draw(g);
//	glEnd();
	glEndList();
}

void CObjet3D::DeleteLists()	// Dtruit toutes les display list de l'objet
{
	if (!this->_pDisplayLists)
		return;

	glDeleteLists(this->_pDisplayLists[0],this->_nbGroupes);
	delete[] this->_pDisplayLists;
	this->_pDisplayLists = NULL;
}

void CObjet3D::Texture(unsigned int t, long g)
{
	materials->AddTexture(this->_pGroupes[g].MaterialId,0);
}

void CObjet3D::InitShadowing()	// alloue l'espace ncessaire  la gnration d'ombres
{
	for (long g=0; g < this->_nbGroupes ;g++)
	{
		this->_pGroupes[g].pFaceShadow = new CFace_ShadowVolume[this->_pGroupes[g].nbFaces];
//		this->_FindNeighbour(g);
	}

	this->_FindNeighbour();
	this->_CalculateFacePlane();
}

void CObjet3D::_PurifyObject()	// supprime les vertex en double dans l'objet
{
	// on regarde toutes les vertex une  une
	for (long v=0; v < this->_nbVertices-1 ;v++)
	{	// on recherche si la vertex existe en double
		for (long duplic=v+1; duplic < this->_nbVertices ;duplic++)
			if (this->_pVertices[v] == this->_pVertices[duplic])
			{	// pour tous les groupes
				for (long g=0; g < this->_nbGroupes ;g++)
					for (long f=0; f < this->_pGroupes[g].nbFaces ;f++) // pour chaque face
						for (int i=0; i < 3 ;i++)	// et chaque indice de la face
						{	// on change l'indice si il est identique  son double
							if (this->_pGroupes[g].pFaces[f].Vertex.abc[i] == duplic)
								this->_pGroupes[g].pFaces[f].Vertex.abc[i] = v;
							// on dcale les autres
							if (this->_pGroupes[g].pFaces[f].Vertex.abc[i] > duplic)
								this->_pGroupes[g].pFaces[f].Vertex.abc[i]--;
						}
				// on dcale ensuite toutes les vertices
				this->_nbVertices--;
				for (long j=duplic; j < this->_nbVertices ;j++)
					this->_pVertices[j] = this->_pVertices[j+1];
			}
	}
}


bool CObjet3D::_LoadOBJ(FILE *fp)	// Charge un objet wavefront (.obj)
{
	char *buf,buftmp[64];
	int lenbuf,i;
	long GroupeFaces[1024];	// pour enregistrer le nombre de faces des groupes rencontrs
	long LastGroupe = 0;	// n dernier groupe rencontr pour vrifier qu'il n'y a pas de problme
									// lors du chargement des donnes, indique combien de groupes ont t rencontrs
	long v,vt,vn,f,g;	// compteur pour le stockage des donnes lors de la seconde passe

// premire passe, on rcupre les infos de l'objet
	while (!feof(fp))
	{
		buf = ReadLine(fp);
		lenbuf = strlen((const char *)buf);
		if (lenbuf >0)
		{
			if(buf[0] == '#')	// commentaire, on regarde ce que c'est
			{
				sscanf(&buf[2],"%s",buftmp);
				lenbuf = strlen(buftmp)+3;
				for (i=0;buf[i+lenbuf]!=0;i++)
					buftmp[i] = buf[i+lenbuf];
				buftmp[i] = 0;
				if (!strcmp((const char *)buftmp,"vertices"))	// on a trouv le nombre de vertices ?
				{
					if (this->_nbVertices == 0)	// si on ne l'avait pas encore trouv
						sscanf(&buf[2],"%lu",&this->_nbVertices);	// on le prend
					else	// sinon
						return false;	// problme dans le fichier obj, on abandonne le chargement
				}
				else if (!strcmp((const char *)buftmp,"texture coordinates"))	// on a trouv le nombre de coordonnes de textures ?
				{
					if (this->_nbTexCoords == 0)	// si on ne l'avait pas encore trouv
						sscanf(&buf[2],"%lu",&this->_nbTexCoords);	// on le prend
					else	// sinon
						return false;	// problme dans le fichier obj, on abandonne le chargement
				}
				else if (!strcmp((const char *)buftmp,"normals"))	// on a trouv le nombre de normales ?
				{
					if (this->_nbNormals == 0)	// si on ne l'avait pas encore trouv
						sscanf(&buf[2],"%lu",&this->_nbNormals);	// on le prend
					else	// sinon
						return false;	// problme dans le fichier obj, on abandonne le chargement
				}
				else if (!strcmp((const char *)buftmp,"triangles in group"))	// fin d'un groupe
				{
					if (this->_nbGroupes > LastGroupe)	// si on a bien rencontr un seul groupe depuis
					{
						sscanf(&buf[2],"%lu",&GroupeFaces[LastGroupe]);	// on rcupre le nombre de faces du groupe
						LastGroupe++;
					}
					else	// sinon
						return false;	// problme dans le fichier obj, on abandonne le chargement
				}
			}
			else if(buf[0] == 'g')	// groupe, on incrmente le compteur de groupes
				this->_nbGroupes++;
		}
		delete[] buf;
	}

// on vrifie qu'on a toutes les infos et on alloue la mmoire
	if (this->_nbGroupes != LastGroupe)	return false;
	if (!this->_nbVertices)		return false;
	if (!this->_nbNormals)		return false;
	if (!this->_nbTexCoords)	return false;
	if (!this->_nbGroupes)		return false;
	this->_Allocate();
	for (LastGroupe = 0;LastGroupe < this->_nbGroupes;LastGroupe++)
	{
		this->_pGroupes[LastGroupe].nbFaces = GroupeFaces[LastGroupe];
		this->_pGroupes[LastGroupe].pFaces = new CFace[this->_pGroupes[LastGroupe].nbFaces];
		this->_pGroupes[LastGroupe].MaterialId = 0;
	}
// seconde passe, on charge les donnes
	fseek(fp,0,SEEK_SET);	// on se repositionne au dbut du fichier
	v	= 0;	// on rinitialise les variables
	vt	= 0;
	vn	= 0;
	f	= 0;
	g	= 0;
	LastGroupe = 0;
	while (!feof(fp))
	{
		buf = ReadLine(fp);
		lenbuf = strlen((const char *)buf);
		if (lenbuf >0)
		{
			sscanf(buf,"%s",buftmp);
			if (!strcmp((const char *)buftmp,"mtllib"))	// on a trouv un matrial  charger ?
				materials->Load(&buf[7]);	// on charge le fichier associ
			if (!strcmp((const char *)buftmp,"v"))	// on a trouv une vertice ?
			{
				if (v >= this->_nbVertices)	// pas normal, on en a trop
					return false;
				sscanf(&buf[2],"%f%f%f",&this->_pVertices[v].xyz[0],&this->_pVertices[v].xyz[1],&this->_pVertices[v].xyz[2]);
				v++;
			}
			if (!strcmp((const char *)buftmp,"vt"))	// on a trouv une coordonne de texture ?
			{
				if (vt >= this->_nbTexCoords)	// pas normal, on en a trop
					return false;
				sscanf(&buf[2],"%f%f",&this->_pTexCoords[vt].xy[0],&this->_pTexCoords[vt].xy[1]);
				vt++;
			}
			if (!strcmp((const char *)buftmp,"vn"))	// on a trouv une normale ?
			{
				if (vn >= this->_nbNormals)	// pas normal, on en a trop
					return false;
				sscanf(&buf[2],"%f%f%f",&this->_pNormals[vn].xyz[0],&this->_pNormals[vn].xyz[1],&this->_pNormals[vn].xyz[2]);
				vn++;
			}
			if (!strcmp((const char *)buftmp,"g"))	// on a trouv un groupe ?
			{
				if (LastGroupe > 0)	// si c'est pas le premier on vrifie
				{
					if (f != this->_pGroupes[g].nbFaces)	// qu'on a toutes les faces
						return false;	// non alors pas bon
					g++; // on passe au groupe suivant
				}
				f = 0;	// sinon on rinitialise
				LastGroupe++;	// on incrmente le compteur de groupes
				this->_pGroupes[g].Name = CString(&buf[2]);
			}
			if (!strcmp((const char *)buftmp,"usemtl"))	// on a trouv un matrial  utiliser ?
				this->_pGroupes[g].MaterialId = materials->GetId(&buf[7]);	// on rcupre son id
			if (!strcmp((const char *)buftmp,"f"))	// on a trouv une face ?
			{
				if (f >= this->_pGroupes[g].nbFaces)	// pas normal, on en a trop
					return false;
				if(LastGroupe != g+1)	// on vrifie qu'on est dans le bon groupe
					return false;
				for (i = 0;(buf[i]<'0')||(buf[i]>'9');i++);	// on se positionne  la premire valeur
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)	// on la rcupre
				{
					this->_pGroupes[g].pFaces[f].Vertex.abc[0] *= 10;	// premire vertice
					this->_pGroupes[g].pFaces[f].Vertex.abc[0] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].Vertex.abc[0]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));	// on se positionne  la valeur suivante
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)	// on la rcupre
				{
					this->_pGroupes[g].pFaces[f].TexCoord.abc[0] *= 10;	// premire coordonne de texture
					this->_pGroupes[g].pFaces[f].TexCoord.abc[0] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].TexCoord.abc[0]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9')); // ect ... il y a 9 indices  rcuprer
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].Normal.abc[0] *= 10;	// premire normale
					this->_pGroupes[g].pFaces[f].Normal.abc[0] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].Normal.abc[0]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].Vertex.abc[1] *= 10;	// seconde vertice
					this->_pGroupes[g].pFaces[f].Vertex.abc[1] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].Vertex.abc[1]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].TexCoord.abc[1] *= 10;	// seconde coordonne de texture
					this->_pGroupes[g].pFaces[f].TexCoord.abc[1] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].TexCoord.abc[1]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].Normal.abc[1] *= 10;	// seconde normale
					this->_pGroupes[g].pFaces[f].Normal.abc[1] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].Normal.abc[1]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].Vertex.abc[2] *= 10;	// troisime et dernire vertice
					this->_pGroupes[g].pFaces[f].Vertex.abc[2] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].Vertex.abc[2]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].TexCoord.abc[2] *= 10;	// troisime et dernire coordonne de texture
					this->_pGroupes[g].pFaces[f].TexCoord.abc[2] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].TexCoord.abc[2]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				do { i++; }while((buf[i]<'0')&&(buf[i]>'9'));
				for (;(buf[i]>='0')&&(buf[i]<='9');i++)
				{
					this->_pGroupes[g].pFaces[f].Normal.abc[2] *= 10;	// troisime et dernire normale
					this->_pGroupes[g].pFaces[f].Normal.abc[2] += buf[i]-0x30;
				}
				this->_pGroupes[g].pFaces[f].Normal.abc[2]--;	// indice n'est pas de 1  nbFaces mais de 0  nbFaces-1
				this->_pGroupes[g].pFaces[f].pVertices = this->_pVertices;	// on indique  la face o se trouvent ses coordonnes de points
				this->_pGroupes[g].pFaces[f].pNormals = this->_pNormals;		// et ses coordonnes de normales
				f++;	// c'tait la dernire valeur, on pointe sur la face suivante pour la suite
			}
		}
		delete[] buf;
	}
	return true;
}

void CObjet3D::_Dummy()	// Vide l'objet et cre un dummy  la place (cube de 1m de cot)
{
	this->_Destroy();
	this->_nbVertices = 8;
	this->_nbNormals = 6;
	this->_nbTexCoords = 4;
	this->_nbGroupes = 1;
	this->_Allocate();
	this->_pVertices[0] = CVector3( 0.5f, 0.5f,-0.5f);
	this->_pVertices[1] = CVector3( 0.5f,-0.5f,-0.5f);
	this->_pVertices[2] = CVector3(-0.5f,-0.5f,-0.5f);
	this->_pVertices[3] = CVector3(-0.5f, 0.5f,-0.5f);
	this->_pVertices[4] = CVector3( 0.5f, 0.5f, 0.5f);
	this->_pVertices[5] = CVector3( 0.5f,-0.5f, 0.5f);
	this->_pVertices[6] = CVector3(-0.5f,-0.5f, 0.5f);
	this->_pVertices[7] = CVector3(-0.5f, 0.5f, 0.5f);
	this->_pNormals[0] = CVector3( 1.0f, 0.0f, 0.0f);
	this->_pNormals[1] = CVector3(-1.0f, 0.0f, 0.0f);
	this->_pNormals[2] = CVector3( 0.0f, 1.0f, 0.0f);
	this->_pNormals[3] = CVector3( 0.0f,-1.0f, 0.0f);
	this->_pNormals[4] = CVector3( 0.0f, 0.0f, 1.0f);
	this->_pNormals[5] = CVector3( 0.0f, 0.0f,-1.0f);
	this->_pTexCoords[0] = CVector2( 0.0f, 0.0f);
	this->_pTexCoords[1] = CVector2( 1.0f, 0.0f);
	this->_pTexCoords[2] = CVector2( 0.0f, 1.0f);
	this->_pTexCoords[3] = CVector2( 1.0f, 1.0f);
	this->_pGroupes[0].Name = CString("Dummy");
	this->_pGroupes[0].nbFaces = 12;
	this->_pGroupes[0].pFaces = new CFace[this->_pGroupes[0].nbFaces];
	this->_pGroupes[0].pFaces[0] = CFace(3,0,1,5,5,5,3,2,0,this->_pVertices,this->_pNormals);	// bottom face
	this->_pGroupes[0].pFaces[1] = CFace(1,2,3,5,5,5,0,1,3,this->_pVertices,this->_pNormals);	
	this->_pGroupes[0].pFaces[2] = CFace(6,5,4,4,4,4,3,2,0,this->_pVertices,this->_pNormals);	// top face
	this->_pGroupes[0].pFaces[3] = CFace(4,7,6,4,4,4,0,1,3,this->_pVertices,this->_pNormals);
	this->_pGroupes[0].pFaces[4] = CFace(2,1,5,3,3,3,3,2,0,this->_pVertices,this->_pNormals);	// front face
	this->_pGroupes[0].pFaces[5] = CFace(5,6,2,3,3,3,0,1,3,this->_pVertices,this->_pNormals);
	this->_pGroupes[0].pFaces[6] = CFace(7,4,0,2,2,2,3,2,0,this->_pVertices,this->_pNormals);// rear face
	this->_pGroupes[0].pFaces[7] = CFace(0,3,7,2,2,2,0,1,3,this->_pVertices,this->_pNormals);
	this->_pGroupes[0].pFaces[8] = CFace(3,2,6,1,1,1,3,2,0,this->_pVertices,this->_pNormals);// left face
	this->_pGroupes[0].pFaces[9] = CFace(6,7,3,1,1,1,0,1,3,this->_pVertices,this->_pNormals);
	this->_pGroupes[0].pFaces[10] = CFace(1,0,4,0,0,0,3,2,0,this->_pVertices,this->_pNormals);// right face
	this->_pGroupes[0].pFaces[11] = CFace(4,5,1,0,0,0,0,1,3,this->_pVertices,this->_pNormals);
	this->_pGroupes[0].MaterialId = 0;
}

void CObjet3D::_DummyMulticolor()	// Vide l'objet et cre un dummy multicolor
{
	SMaterial mTmp;

	this->_Destroy();
	this->_nbVertices = 8;
	this->_nbNormals = 6;
	this->_nbTexCoords = 4;
	this->_nbGroupes = 6;
	this->_Allocate();
	this->_pVertices[0] = CVector3( 0.5f, 0.5f,-0.5f);
	this->_pVertices[1] = CVector3( 0.5f,-0.5f,-0.5f);
	this->_pVertices[2] = CVector3(-0.5f,-0.5f,-0.5f);
	this->_pVertices[3] = CVector3(-0.5f, 0.5f,-0.5f);
	this->_pVertices[4] = CVector3( 0.5f, 0.5f, 0.5f);
	this->_pVertices[5] = CVector3( 0.5f,-0.5f, 0.5f);
	this->_pVertices[6] = CVector3(-0.5f,-0.5f, 0.5f);
	this->_pVertices[7] = CVector3(-0.5f, 0.5f, 0.5f);
	this->_pNormals[0] = CVector3( 1.0f, 0.0f, 0.0f);
	this->_pNormals[1] = CVector3(-1.0f, 0.0f, 0.0f);
	this->_pNormals[2] = CVector3( 0.0f, 1.0f, 0.0f);
	this->_pNormals[3] = CVector3( 0.0f,-1.0f, 0.0f);
	this->_pNormals[4] = CVector3( 0.0f, 0.0f, 1.0f);
	this->_pNormals[5] = CVector3( 0.0f, 0.0f,-1.0f);
	this->_pTexCoords[0] = CVector2( 0.0f, 0.0f);
	this->_pTexCoords[1] = CVector2( 1.0f, 0.0f);
	this->_pTexCoords[2] = CVector2( 0.0f, 1.0f);
	this->_pTexCoords[3] = CVector2( 1.0f, 1.0f);
	this->_pGroupes[0].Name = CString("Dummy01");
	this->_pGroupes[0].nbFaces = 2;
	this->_pGroupes[0].pFaces = new CFace[this->_pGroupes[0].nbFaces];
	this->_pGroupes[0].pFaces[0] = CFace(2,1,5,3,3,3,3,2,0,this->_pVertices,this->_pNormals);	// front face
	this->_pGroupes[0].pFaces[1] = CFace(7,4,0,2,2,2,3,2,0,this->_pVertices,this->_pNormals);	// rear face
	mTmp.Name = this->_pGroupes[0].Name;
	mTmp.Ka = CVector4(0.1f,0.1f,0.1f,1.0f);
	mTmp.Kd = CVector4(1.0f,0.1f,0.0f,1.0f);
	mTmp.Ks = CVector4(1.0f,0.9f,0.9f,1.0f);
	mTmp.Ns = 10.0f;
	mTmp.nbTex = 0;
	this->_pGroupes[0].MaterialId = materials->Create(&mTmp);

	this->_pGroupes[1].Name = CString("Dummy02");
	this->_pGroupes[1].nbFaces = 2;
	this->_pGroupes[1].pFaces = new CFace[this->_pGroupes[1].nbFaces];
	this->_pGroupes[1].pFaces[0] = CFace(5,6,2,3,3,3,0,1,3,this->_pVertices,this->_pNormals);	// front face
	this->_pGroupes[1].pFaces[1] = CFace(0,3,7,2,2,2,0,1,3,this->_pVertices,this->_pNormals);	// rear face
	mTmp.Name = this->_pGroupes[1].Name;
	mTmp.Kd = CVector4(1.0f,0.1f,0.0f,1.0f);
	mTmp.Ks = CVector4(1.0f,0.9f,0.9f,1.0f);
	this->_pGroupes[1].MaterialId = materials->Create(&mTmp);

	this->_pGroupes[2].Name = CString("Dummy03");
	this->_pGroupes[2].nbFaces = 2;
	this->_pGroupes[2].pFaces = new CFace[this->_pGroupes[2].nbFaces];
	this->_pGroupes[2].pFaces[0] = CFace(3,0,1,5,5,5,3,2,0,this->_pVertices,this->_pNormals);	// bottom face
	this->_pGroupes[2].pFaces[1] = CFace(6,5,4,4,4,4,3,2,0,this->_pVertices,this->_pNormals);	// top face
	mTmp.Name = this->_pGroupes[2].Name;
	mTmp.Kd = CVector4(1.0f,0.1f,0.0f,1.0f);
	mTmp.Ks = CVector4(1.0f,0.9f,0.9f,1.0f);
	this->_pGroupes[2].MaterialId = materials->Create(&mTmp);

	this->_pGroupes[3].Name = CString("Dummy04");
	this->_pGroupes[3].nbFaces = 2;
	this->_pGroupes[3].pFaces = new CFace[this->_pGroupes[3].nbFaces];
	this->_pGroupes[3].pFaces[0] = CFace(1,2,3,5,5,5,0,1,3,this->_pVertices,this->_pNormals);	// bottom face
	this->_pGroupes[3].pFaces[1] = CFace(4,7,6,4,4,4,0,1,3,this->_pVertices,this->_pNormals);	// top face
	mTmp.Name = this->_pGroupes[3].Name;
	mTmp.Kd = CVector4(1.0f,0.1f,0.0f,1.0f);
	mTmp.Ks = CVector4(1.0f,0.9f,0.9f,1.0f);
	this->_pGroupes[3].MaterialId = materials->Create(&mTmp);

	this->_pGroupes[4].Name = CString("Dummy05");
	this->_pGroupes[4].nbFaces = 2;
	this->_pGroupes[4].pFaces = new CFace[this->_pGroupes[4].nbFaces];
	this->_pGroupes[4].pFaces[0] = CFace(3,2,6,1,1,1,3,2,0,this->_pVertices,this->_pNormals);	// left face
	this->_pGroupes[4].pFaces[1] = CFace(1,0,4,0,0,0,3,2,0,this->_pVertices,this->_pNormals);	// right face
	mTmp.Name = this->_pGroupes[4].Name;
	mTmp.Kd = CVector4(1.0f,0.1f,0.0f,1.0f);
	mTmp.Ks = CVector4(1.0f,0.9f,0.9f,1.0f);
	this->_pGroupes[4].MaterialId = materials->Create(&mTmp);

	this->_pGroupes[5].Name = CString("Dummy06");
	this->_pGroupes[5].nbFaces = 2;
	this->_pGroupes[5].pFaces = new CFace[this->_pGroupes[5].nbFaces];
	this->_pGroupes[5].pFaces[0] = CFace(6,7,3,1,1,1,0,1,3,this->_pVertices,this->_pNormals);	// left face
	this->_pGroupes[5].pFaces[1] = CFace(4,5,1,0,0,0,0,1,3,this->_pVertices,this->_pNormals);	// right face
	mTmp.Name = this->_pGroupes[5].Name;
	mTmp.Kd = CVector4(1.0f,0.1f,0.0f,1.0f);
	mTmp.Ks = CVector4(1.0f,0.9f,0.9f,1.0f);
	this->_pGroupes[5].MaterialId = materials->Create(&mTmp);
}

void CObjet3D::_Allocate()
{
	_pVertices = new CVector3[this->_nbVertices];
	_pNormals = new CVector3[this->_nbNormals];
	_pTexCoords = new CVector2[this->_nbTexCoords];
	_pGroupes = new SGroupe3[this->_nbGroupes];
	_pGroupes->Name = CString();
	_pGroupes->nbFaces = 0;
	_pGroupes->pFaces = NULL;
	_pGroupes->MaterialId = 0;
}

void CObjet3D::_Destroy()
{
	if (!this->_pVertices)
		return;
	this->DeleteLists();
	for (long g=0; g < this->_nbGroupes ;g++)
	{
		delete[] this->_pGroupes[g].pFaces;
		delete[] this->_pGroupes[g].pFaceShadow;
	}
	delete[] this->_pGroupes;
	delete[] this->_pTexCoords;
	delete[] this->_pNormals;
	delete[] this->_pVertices;
	this->_nbGroupes	= 0;
	this->_nbNormals	= 0;
	this->_nbTexCoords	= 0;
	this->_nbVertices	= 0;
}

void CObjet3D::_FindNeighbour(long g)	// trouve les 3 faces voisines  chaques faces de l'objet
{
	unsigned int p1i, p2i, p1j, p2j;
	unsigned int P1i, P2i, P1j, P2j;

	for (long f=0; f < this->_pGroupes[g].nbFaces ;f++)
		this->_pGroupes[g].pFaceShadow[f].Neighbour = 0;

	for(f=0; f < this->_pGroupes[g].nbFaces-1 ;f++)
		for(long f2=f+1; f2 < this->_pGroupes[g].nbFaces ;f2++)
			for(long ki=0; ki < 3 ;ki++)
				if(!this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[ki])
				{
					for(long kj=0; kj < 3 ;kj++)
					{
						p1i = ki;
						p1j = kj;
						p2i = (ki+1)%3;
						p2j = (kj+1)%3;

						p1i = this->_pGroupes[g].pFaces[f].Vertex.abc[p1i];
						p2i = this->_pGroupes[g].pFaces[f].Vertex.abc[p2i];
						p1j = this->_pGroupes[g].pFaces[f2].Vertex.abc[p1j];
						p2j = this->_pGroupes[g].pFaces[f2].Vertex.abc[p2j];

						P1i = ((p1i+p2i)-abs(p1i-p2i))/2;
						P2i = ((p1i+p2i)+abs(p1i-p2i))/2;
						P1j = ((p1j+p2j)-abs(p1j-p2j))/2;
						P2j = ((p1j+p2j)+abs(p1j-p2j))/2;

						if((P1i==P1j) && (P2i==P2j)) // on a deux voisins
						{
							this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[ki] = f2+1;	  
							this->_pGroupes[g].pFaceShadow[f2].Neighbour.abc[kj] = f+1;	  
						}
					}
				}
}

void CObjet3D::_FindNeighbour()	// trouve les 3 faces voisines  chaques faces de l'objet
{
	if ( (this->_nbGroupes <= 0) || ((this->_nbGroupes > 0) && (!this->_pGroupes[0].pFaceShadow)) )
			return;

	for (long g=0; g < this->_nbGroupes; g++)	// pour chaque groupe de l'objet
		for (long f=0; f < this->_pGroupes[g].nbFaces ;f++)	// pour chaque face du groupe
		{
			long a = this->_pGroupes[g].pFaces[f].Vertex.abc[0];
			long b = this->_pGroupes[g].pFaces[f].Vertex.abc[1];
			this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[0] = f;
			for (long f2=0; f2 < this->_pGroupes[g].nbFaces ;f2++)	// on teste chaque face de l'objet
				if (f2 != f)	// sauf s'il s'agit de la mme face
				{
					if ( ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[0])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[1]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[0])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[2]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[0]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[2]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[2])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[0]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[2])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])) )
					{
						this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[0] = f2;
						f2 = this->_pGroupes[g].nbFaces;
					}
				}
			a = this->_pGroupes[g].pFaces[f].Vertex.abc[0];
			b = this->_pGroupes[g].pFaces[f].Vertex.abc[2];
			this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[1] = f;
			for (f2=0; f2 < this->_pGroupes[g].nbFaces ;f2++)	// on teste chaque face de l'objet
				if (f2 != f)	// sauf s'il s'agit de la mme face
				{
					if ( ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[0])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[1]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[0])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[2]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[0]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[2]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[2])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[0]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[2])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])) )
					{
						this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[1] = f2;
						f2 = this->_pGroupes[g].nbFaces;
					}
				}
			a = this->_pGroupes[g].pFaces[f].Vertex.abc[1];
			b = this->_pGroupes[g].pFaces[f].Vertex.abc[2];
			this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[2] = f;
			for (f2=0; f2 < this->_pGroupes[g].nbFaces ;f2++)	// on teste chaque face de l'objet
				if (f2 != f)	// sauf s'il s'agit de la mme face
				{
					if ( ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[0])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[1]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[0])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[2]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[0]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[2]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[2])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[0]))
						|| ((a==this->_pGroupes[g].pFaces[f2].Vertex.abc[2])&&(b==this->_pGroupes[g].pFaces[f2].Vertex.abc[1])) )
					{
						this->_pGroupes[g].pFaceShadow[f].Neighbour.abc[2] = f2;
						f2 = this->_pGroupes[g].nbFaces;
					}
				}
		}
}

void CObjet3D::_CalculateFacePlane()	// calcule l'quation de plan de chaque face
{
	if ( (this->_nbGroupes <= 0) || ((this->_nbGroupes > 0) && (!this->_pGroupes[0].pFaceShadow)) )
			return;

	for (long g=0; g < this->_nbGroupes ; g++)
		for (long f=0; f < this->_pGroupes[g].nbFaces ;f++)
			this->_pGroupes[g].pFaceShadow[f].PlaneEquation = this->_pGroupes[g].pFaces[f].CalculatePlane();
}

SVolume3D * CObjet3D::_Silhouette(long g, CVector3 &source)	// gnre la silhouette du groupe g de l'objet vu depuis la position view
{
	long nbEdges = 0;
	SVolume3D *Sil = new SVolume3D;
	CVector4 view(source,1.0f);

	// dans un premier temps, on met  jour la liste des faces visibles
	for (long f=0; f < this->_pGroupes[g].nbFaces ;f++)
	{
		if (this->_pGroupes[g].pFaceShadow[f].PlaneEquation.Dot(view) > 0)
			this->_pGroupes[g].pFaceShadow[f].isVisible = true;
		else
			this->_pGroupes[g].pFaceShadow[f].isVisible = false;
	}

	// puis on compte combien d'aretes composent la silhouette
	for (f=0; f < this->_pGroupes[g].nbFaces ;f++)
	{
		if (this->_pGroupes[g].pFaceShadow[f].isVisible) // si la face est visible
		{
			CIndice3 voisin(this->_pGroupes[g].pFaceShadow[f].Neighbour);
			if (!this->_pGroupes[g].pFaceShadow[voisin.abc[0]].isVisible) // le 1er voisin n'est pas visible, on dessine l'arete
				nbEdges++;
			if (!this->_pGroupes[g].pFaceShadow[voisin.abc[1]].isVisible) // le 2nd voisin n'est pas visible, on dessine l'arete
				nbEdges++;
			if (!this->_pGroupes[g].pFaceShadow[voisin.abc[2]].isVisible) // le 3eme voisin n'est pas visible, on dessine l'arete
				nbEdges++;
		}
	}
	Sil->Edges = new SEdge3D[nbEdges];
	Sil->nbEdges = nbEdges;
	// on rcupre les coordonnes des arretes qui composent la silhouette
	for (f=0,nbEdges=0; f < this->_pGroupes[g].nbFaces ;f++)
	{
		if (this->_pGroupes[g].pFaceShadow[f].isVisible) // si la face est visible
		{
			CIndice3 voisin(this->_pGroupes[g].pFaceShadow[f].Neighbour);
			if (!this->_pGroupes[g].pFaceShadow[voisin.abc[0]].isVisible) // le 1er voisin n'est pas visible, on dessine l'arete
			{
				Sil->Edges[nbEdges].v[0] = this->_pGroupes[g].pFaces[f].pVertices[this->_pGroupes[g].pFaces[f].Vertex.abc[0]];
				Sil->Edges[nbEdges].v[1] = this->_pGroupes[g].pFaces[f].pVertices[this->_pGroupes[g].pFaces[f].Vertex.abc[1]];
				nbEdges++;
			}
			if (!this->_pGroupes[g].pFaceShadow[voisin.abc[1]].isVisible) // le 2nd voisin n'est pas visible, on dessine l'arete
			{
				Sil->Edges[nbEdges].v[0] = this->_pGroupes[g].pFaces[f].pVertices[this->_pGroupes[g].pFaces[f].Vertex.abc[2]];
				Sil->Edges[nbEdges].v[1] = this->_pGroupes[g].pFaces[f].pVertices[this->_pGroupes[g].pFaces[f].Vertex.abc[0]];
				nbEdges++;
			}
			if (!this->_pGroupes[g].pFaceShadow[voisin.abc[2]].isVisible) // le 3eme voisin n'est pas visible, on dessine l'arete
			{
				Sil->Edges[nbEdges].v[0] = this->_pGroupes[g].pFaces[f].pVertices[this->_pGroupes[g].pFaces[f].Vertex.abc[1]];
				Sil->Edges[nbEdges].v[1] = this->_pGroupes[g].pFaces[f].pVertices[this->_pGroupes[g].pFaces[f].Vertex.abc[2]];
				nbEdges++;
			}
		}
	}

	// pour terminer on trie les aretes pour mettre les points bout  bout
/*	CVector3 v1,v2;
	bool sortir_boucle1;
	for (long edge0 = 0; edge0 < nbEdges-1 ;edge0++)
	{
		sortir_boucle1 = false;
		for (long compr = edge0+1; (compr < nbEdges)&&(!sortir_boucle1) ;compr++)
		{
			if (Sil->Edges[edge0].v[1] == Sil->Edges[compr].v[0])
			{
				v1 = Sil->Edges[compr].v[0];
				v2 = Sil->Edges[compr].v[1];
				Sil->Edges[compr].v[0] = Sil->Edges[edge0+1].v[0];
				Sil->Edges[compr].v[1] = Sil->Edges[edge0+1].v[1];
				Sil->Edges[edge0+1].v[0] = v1;
				Sil->Edges[edge0+1].v[1] = v2;
				sortir_boucle1 = true;
			}
			else if (Sil->Edges[edge0].v[1] == Sil->Edges[compr].v[1])
			{
				v1 = Sil->Edges[compr].v[1];
				v2 = Sil->Edges[compr].v[0];
				Sil->Edges[compr].v[0] = Sil->Edges[edge0+1].v[0];
				Sil->Edges[compr].v[1] = Sil->Edges[edge0+1].v[1];
				Sil->Edges[edge0+1].v[0] = v1;
				Sil->Edges[edge0+1].v[1] = v2;
				sortir_boucle1 = true;
			}
		}
	}*/

	return Sil;
}