#include "CSkyBox.h"
#include "CMaterial.h"
#include "CTexture.h"
#include "CVector2.h"
#include "CVector3.h"

extern CMaterial *materials;
extern CTexture *textures;

CSkyBox::CSkyBox(int type)
{
	unsigned int TexturesId[6];
	TexturesId[__HCSkyBox__CUBE_TOP] = textures->Load("SB_Top.bmp",__HCTexture__TEXPARAM_CLAMP_S_T);
	TexturesId[__HCSkyBox__CUBE_BOTTOM] = textures->Load("SB_Bottom.bmp",__HCTexture__TEXPARAM_CLAMP_S_T);
	TexturesId[__HCSkyBox__CUBE_FRONT] = textures->Load("SB_Front.bmp",__HCTexture__TEXPARAM_CLAMP_S_T);
	TexturesId[__HCSkyBox__CUBE_REAR] = textures->Load("SB_Rear.bmp",__HCTexture__TEXPARAM_CLAMP_S_T);
	TexturesId[__HCSkyBox__CUBE_RIGHT] = textures->Load("SB_Right.bmp",__HCTexture__TEXPARAM_CLAMP_S_T);
	TexturesId[__HCSkyBox__CUBE_LEFT] = textures->Load("SB_Left.bmp",__HCTexture__TEXPARAM_CLAMP_S_T);

	CVector4 a(1.0f,1.0f,1.0f,1.0f);
	CVector4 d(1.0f,1.0f,1.0f,1.0f);
	CVector4 s(0.0f,0.0f,0.0f,1.0f);
	CVector4 e(0.0f,0.0f,0.0f,1.0f);
	this->SB_Material[__HCSkyBox__CUBE_TOP] = materials->Create("SB_Top",a,d,s,e,0.0f);
	materials->AddTexture(this->SB_Material[__HCSkyBox__CUBE_TOP],TexturesId[__HCSkyBox__CUBE_TOP]);
	this->SB_Material[__HCSkyBox__CUBE_BOTTOM] = materials->Create("SB_Bottom",a,d,s,e,0.0f);
	materials->AddTexture(this->SB_Material[__HCSkyBox__CUBE_BOTTOM],TexturesId[__HCSkyBox__CUBE_BOTTOM]);
	this->SB_Material[__HCSkyBox__CUBE_FRONT] = materials->Create("SB_Front",a,d,s,e,0.0f);
	materials->AddTexture(this->SB_Material[__HCSkyBox__CUBE_FRONT],TexturesId[__HCSkyBox__CUBE_FRONT]);
	this->SB_Material[__HCSkyBox__CUBE_REAR] = materials->Create("SB_Rear",a,d,s,e,0.0f);
	materials->AddTexture(this->SB_Material[__HCSkyBox__CUBE_REAR],TexturesId[__HCSkyBox__CUBE_REAR]);
	this->SB_Material[__HCSkyBox__CUBE_RIGHT] = materials->Create("SB_Right",a,d,s,e,0.0f);
	materials->AddTexture(this->SB_Material[__HCSkyBox__CUBE_RIGHT],TexturesId[__HCSkyBox__CUBE_RIGHT]);
	this->SB_Material[__HCSkyBox__CUBE_LEFT] = materials->Create("SB_Left",a,d,s,e,0.0f);
	materials->AddTexture(this->SB_Material[__HCSkyBox__CUBE_LEFT],TexturesId[__HCSkyBox__CUBE_LEFT]);
}

CSkyBox::~CSkyBox()
{
}

void CSkyBox::Draw(float sb_size)
{
	glDisable(GL_LIGHTING);

	materials->SetMat(this->SB_Material[__HCSkyBox__CUBE_FRONT]);
//	glShadeModel (GL_FLAT);
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f,1.0f);
		glVertex3f( sb_size, sb_size, sb_size);
		glTexCoord2f(1.0f,0.0f);
		glVertex3f( sb_size,-sb_size, sb_size);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f(-sb_size,-sb_size, sb_size);
		glTexCoord2f(0.0f,1.0f);
		glVertex3f(-sb_size, sb_size, sb_size);
	glEnd();

	materials->SetMat(this->SB_Material[__HCSkyBox__CUBE_REAR]);
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f,1.0f);
		glVertex3f(-sb_size, sb_size,-sb_size);
		glTexCoord2f(1.0f,0.0f);
		glVertex3f(-sb_size,-sb_size,-sb_size);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f( sb_size,-sb_size,-sb_size);
		glTexCoord2f(0.0f,1.0f);
		glVertex3f( sb_size, sb_size,-sb_size);
	glEnd();

	materials->SetMat(this->SB_Material[__HCSkyBox__CUBE_TOP]);
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f,0.0f);
		glVertex3f(-sb_size, sb_size, sb_size);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f(-sb_size, sb_size,-sb_size);
		glTexCoord2f(0.0f,1.0f);
		glVertex3f( sb_size, sb_size,-sb_size);
		glTexCoord2f(1.0f,1.0f);
		glVertex3f( sb_size, sb_size, sb_size);
	glEnd();

	materials->SetMat(this->SB_Material[__HCSkyBox__CUBE_BOTTOM]);
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f,0.0f);
		glVertex3f( sb_size,-sb_size, sb_size);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f( sb_size,-sb_size,-sb_size);
		glTexCoord2f(0.0f,1.0f);
		glVertex3f(-sb_size,-sb_size,-sb_size);
		glTexCoord2f(1.0f,1.0f);
		glVertex3f(-sb_size,-sb_size, sb_size);
	glEnd();

	materials->SetMat(this->SB_Material[__HCSkyBox__CUBE_RIGHT]);
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f,1.0f);
		glVertex3f(-sb_size, sb_size, sb_size);
		glTexCoord2f(1.0f,0.0f);
		glVertex3f(-sb_size,-sb_size, sb_size);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f(-sb_size,-sb_size,-sb_size);
		glTexCoord2f(0.0f,1.0f);
		glVertex3f(-sb_size, sb_size,-sb_size);
	glEnd();

	materials->SetMat(this->SB_Material[__HCSkyBox__CUBE_LEFT]);
	glBegin(GL_QUADS);
		glTexCoord2f(1.0f,1.0f);
		glVertex3f( sb_size, sb_size,-sb_size);
		glTexCoord2f(1.0f,0.0f);
		glVertex3f( sb_size,-sb_size,-sb_size);
		glTexCoord2f(0.0f,0.0f);
		glVertex3f( sb_size,-sb_size, sb_size);
		glTexCoord2f(0.0f,1.0f);
		glVertex3f( sb_size, sb_size, sb_size);
	glEnd();

	glEnable (GL_LIGHTING);
}