#include <string.h>

#include "CString.h"

CString::CString()	// Constructeur par dfaut : chaine vide de longueur 1
{
	this->pucstr = new char[1];
	this->pucstr[0] = 0;
}

CString::CString(CString &s)	// Cre la CString par duplication d'une autre CString
{
	this->pucstr = new char[s.GetLength()+1];
	strcpy(this->pucstr,s.pucstr);
}

CString::CString(char *chaine, int chainelength)	// Cre la CString  partir d'une chaine en prenant chainelength caractres
{
	this->pucstr = new char[chainelength+1];
	for (int i=0;i<chainelength;i++)
		this->pucstr[i]=chaine[i];
	this->pucstr[i] = 0;
}

CString::CString(char *chaine)	// Cre la CString  partir d'une chaine
{
	int lengthofstr = strlen(chaine);
	this->pucstr = new char[lengthofstr+1];
	for (int i=0;i<lengthofstr;i++)
		this->pucstr[i]=chaine[i];
	this->pucstr[i] = 0;
}

CString::~CString()	// Destructeur
{
	delete[] this->pucstr;
}

long CString::GetLength()	// Retourne la longueur d'une chaine (nombre de caractres)
{
	return strlen(this->pucstr);
}

bool CString::IsEmpty()	// Retourne vrai si la chaine est vide
{
	return (this->pucstr[0]==0);
}

void CString::Empty()	// Met la chaine  une longueur de 0
{
	delete[] this->pucstr;
	this->pucstr = new char[1];
	this->pucstr[0] = 0;
}

bool CString::Compare(char *chaine)	// Compare la CString avec une chaine  (case sensitive)
{
	long l=this->GetLength();
	if ((long)strlen(chaine) != l)
		return false;
	for (;(l>=0)&&(this->pucstr[l]==chaine[l]);l--);
	return l<0;
}

//bool CString::CompareNoCase(unsigned char *chaine)	// Compare la CString avec une chaine (case insensitive)
//bool CString::Compare(CString &chaine)	// Compare la CString avec une autre CString  (case sensitive)
//bool CString::CompareNoCase(CString &chaine)	// Compare la CString avec une autre CString (case insensitive)
//CString CString::Mid(int premier)	// Extrait une partie de la chaine, de premier  length - premier
//CString CString::Mid(int premier, int count)	// Extrait une partie de la chaine, de premier  premier + count
//CString CString::Left(int count)	// Extrait count caractres depuis le dbut de la chaine
//CString CString::Right(int count)	// Extrait count caractres depuis la fin de la chaine
//CString CString::SpanIncluding(unsigned char *chaine) // Extrait une chaine de la CString ne contenant que les caractres contenus dans chaine
//CString CString::SpanExcluding(unsigned char *chaine) // Extrait une chaine de CString ne contenant que les caractres ne faisant pas partie de chaine
//void CString::MakeUpper() // Convertit la chaine en majuscules
//void CString::MakeLower() // convertit la chaine en minuscules
//void CString::MakeReverse() // Inverse la chaine (debut<->fin)
//void CString::TrimAll() // Retire les espaces, les tabulations et les retours chariot de la CString
//void CString::TrimAll(unsigned char *chaine) // Retire de la CString les caractres contenus dans chaine
//void CString::TrimLeft() // Retire les espaces, les tabulations et les retours chariot au dbut de la CString
//void CString::TrimLeft(unsigned char *chaine) // Retire du dbut de la CString les caractres contenus dans chaine
//void CString::TrimRight() // Retire les espaces, les tabulations et les retours chariot  la fin de la CString
//void CString::TrimRight(unsigned char *chaine) // Retire de la fin de la CString les caractres contenus dans chaine

/////////////////////
//	Les oprateurs //
/////////////////////

void CString::operator = (CString &s)
{
	delete[] this->pucstr;
	this->pucstr = new char[s.GetLength()+1];
	strcpy(this->pucstr,s.pucstr);
}

void CString::operator = (char *s)
{
	delete[] this->pucstr;
	this->pucstr = new char[strlen(s)+1];
	strcpy(this->pucstr,s);
}

CString CString::operator + (CString &s)
{
	int l1 = this->GetLength();
	int l2 = s.GetLength();
	char *newchaine = new char[l1+l2+1];

	for (int i=0;i<l1;i++)
		newchaine[i] = this->pucstr[i];
	for (int j=0;j<l2;j++)
		newchaine[i] = s.pucstr[j];
	newchaine[i] = 0;
	return CString(newchaine);
}

void CString::operator += (CString &s)
{
	int l1 = this->GetLength();
	int l2 = s.GetLength();
	char *newchaine = new char[l1+l2+1];

	for (int i=0;i<l1;i++)
		newchaine[i] = this->pucstr[i];
	for (int j=0;j<l2;j++)
		newchaine[i] = s.pucstr[j];
	newchaine[i] = 0;
	delete[] this->pucstr;
	this->pucstr = newchaine;
}

bool CString::operator == (CString &s)
{
	long l = this->GetLength();
	if (s.GetLength() != l)
		return false;
	for (;(l>=0)&&(this->pucstr[l]==s.pucstr[l]);l--);
	return l<0;
}

bool CString::operator != (CString &s)
{
	int l = this->GetLength();
	if (s.GetLength() != l)
		return true;
	for (;(l>=0)&&(this->pucstr[l]==s.pucstr[l]);l--);
	return l>=0;
}