#ifndef __HCString__
#define __HCString__

class CString
{
public:
	char *pucstr;

	CString();	// Constructeur par dfaut : chaine vide de longueur 1
	CString(CString &s);	// Cre la CString par duplication d'une autre CString
	CString(char *chaine, int chainelength);	// Cre la CString  partir d'une chaine en prenant chainelength caractres
	CString(char *chaine);	// Cre la CString  partir d'une chaine
	~CString();	// Destructeur
	long GetLength(void);	// Retourne la longueur d'une chaine (nombre de caractres)
	bool IsEmpty(void);	// Retourne vrai si la chaine est vide
	void Empty(void);	// Met la chaine  une longueur de 0
	bool Compare(char *chaine);	// Compare la CString avec une chaine  (case sensitive)
	bool CompareNoCase(char *chaine);	// Compare la CString avec une chaine (case insensitive)
	bool Compare(CString &chaine);	// Compare la CString avec une autre CString  (case sensitive)
	bool CompareNoCase(CString &chaine);	// Compare la CString avec une autre CString (case insensitive)
	CString Mid(int premier);	// Extrait une partie de la chaine, de premier  length - premier
	CString Mid(int premier, int count);	// Extrait une partie de la chaine, de premier  premier + count
	CString Left(int count);	// Extrait count caractres depuis le dbut de la chaine
	CString Right(int count);	// Extrait count caractres depuis la fin de la chaine
	CString SpanIncluding(char *chaine); // Extrait une chaine de la CString ne contenant que les caractres contenus dans chaine
	CString SpanExcluding(char *chaine); // Extrait une chaine de CString ne contenant que les caractres ne faisant pas partie de chaine
	void MakeUpper(void); // Convertit la chaine en majuscules
	void MakeLower(void); // convertit la chaine en minuscules
	void MakeReverse(void); // Inverse la chaine (debut<->fin)
	void TrimAll(void); // Retire les espaces, les tabulations et les retours chariot de la CString
	void TrimAll(char *chaine); // Retire de la CString les caractres contenus dans chaine
	void TrimLeft(void); // Retire les espaces, les tabulations et les retours chariot au dbut de la CString
	void TrimLeft(char *chaine); // Retire du dbut de la CString les caractres contenus dans chaine
	void TrimRight(void); // Retire les espaces, les tabulations et les retours chariot  la fin de la CString
	void TrimRight(char *chaine); // Retire de la fin de la CString les caractres contenus dans chaine

	void operator = (CString &s);
	void operator = (char *s);
	CString operator + (CString &s);
	void operator += (CString &s);
	bool operator == (CString &s);
	bool operator != (CString &s);

	char &operator[](unsigned int index){ return *(((char *) pucstr) + index); }
};

#endif // __HCString__
