#include <windows.h>
#include <gl/gl.h>

#include "CTerrain.h"

extern CMaterial *materials;
extern CTexture *textures;

CTerrain::CTerrain()
{
	GroundMaterial.Name = CString("Ground Material");
	GroundMaterial.idTex[0] = textures->Load("Herbe.bmp",__HCTexture__TEXPARAM_REPEATALL);
	GroundMaterial.nbTex = 1;
	GroundMaterial.Ka = CVector4(1.0f,1.0f,1.0f,1.0f);
	GroundMaterial.Kd = CVector4(1.0f,1.0f,1.0f,1.0f);
	GroundMaterial.Ks = CVector4(0.0f,0.0f,0.0f,0.0f);
	GroundMaterial.Ke = CVector4(0.0f,0.0f,0.0f,0.0f);
	GroundMaterial.Ns = 0.0f;
	materials->Create(&GroundMaterial);
}

CTerrain::~CTerrain()
{
}

void CTerrain::Draw(float size)
{
	materials->SetMat(materials->GetId(GroundMaterial.Name));
	glBegin(GL_QUADS);
		glNormal3f(0.0f,1.0f,0.0f);
		 glTexCoord2f(0.0f,0.0f);
		glVertex3f(-size, 0.0f, size);
		 glTexCoord2f(size,0.0f);
		glVertex3f( size, 0.0f, size);
		 glTexCoord2f(size,size);
		glVertex3f( size, 0.0f,-size);
		 glTexCoord2f(0.0f,size);
		glVertex3f(-size, 0.0f,-size);
	glEnd();
}