#ifndef __HCTexture__
#define __HCTexture__

#define __HCTexture__MAX_TEXTURES	64
#define __HCTexture__NEED_SPACE		16

// les diffrents formats de textures
#define	__HCTexture__4444rgba	161
#define	__HCTexture__5551rgba	162
#define __HCTexture__8888rgba	321
#define __HCTexture__888rgb		241

// les types de textures
#define __HCTexture__TYPE_SINGLE		1
#define __HCTexture__TYPE_LIGHMAP		4
#define __HCTexture__TYPE_DOT3BUMPMAP	8
#define __HCTexture__TYPE_SPHEREMAP		16
#define __HCTexture__TYPE_CUBEMAP		32

// les paramtres de warping
#define __HCTexture__TEXPARAM_REPEATALL		0
#define __HCTexture__TEXPARAM_CLAMP_S		1	// si actif, on clamp sinon on repeat la texture
#define __HCTexture__TEXPARAM_CLAMP_T		2
#define __HCTexture__TEXPARAM_CLAMP_S_T		3

#include <windows.h>
#include <gl/gl.h>

#include "CString.h"

typedef struct {
	unsigned int target,	// GL_TEXTURE_1D ou GL_TEXTURE_2D
		type,	// type de texture
		width,height;	// dimensions de la texture
	CString Name;	// nom du fichier associ  la texture
	GLenum format;	// format de la texture (dtermine le nombre de composantes et si canal alpha)
}STexture;

class CTexture {
public:
	CTexture();	// constructeur
	~CTexture();	// destructeur
	unsigned int Load(char *filename,int texParam);	// charge une texture
	void SetTex(unsigned int n,unsigned int *pId);	// active les n textures dont les indices sont contenus dans pId
	void NoTexture(void);	// dsactive le texturing par rapport  l'activation prcdente
//	void UnLoad(unsigned int t);	// dcharge la texture de la mmoire
	unsigned int GetId(char *name);	// retourne l'id d'une texture, 0 si inexistante
	unsigned int GetId(CString name);	// retourne l'id d'une texture, 0 si inexistante

private:
	void _AddTextures(void);	// augmente de __HCTexture__NEED_SPACE le nombre de nombre de textures pouvant tre charges
	// Note : les formats Jpeg et Png ne grent pas la transparence
	unsigned char * _LoadBmp(STexture *psdata);
	unsigned char * _LoadDds(STexture *psdata);	// Charge le fichier dds psdata->Name, met  jour la structure et retourne un pointeur sur les donnes
	unsigned char * _LoadJpg(STexture *psdata);
	unsigned char * _LoadPng(STexture *psdata);
	unsigned char * _LoadRaw(STexture *psdata);	// Charge un fichier .raw (donnes brut)
	unsigned char * _LoadTga(STexture *psdata);
	unsigned char * _IsLoaded(char *filename);
	void _GenerateDefaultTexture(void);	// gnre la texture par dfaut (id=0)

	STexture *_pTexInf;	// le tableau des infos sur les textures
	unsigned int *_pTexId;	// le tableau des textures (id opengl)
	unsigned int _nbTex;
	unsigned int _nbMaxTex;
	unsigned int *_pLastCalled;
	long _nbLastCalled;
};

#endif // __HCTexture__
