/***********************************************\
	Premier contact avec SDL
*************************************************
	Games Design, www.gamesdesign.net
	par Groove, groove@gamesdesign.net
*************************************************
	main_sdl.cpp, 28/01/2004
\***********************************************/

#include <windows.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <SDL.h>

#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>

#include "MainLoop.h"

#define FENETRE_NOM			"SDL - OGL - Application"
#define FENETRE_LARGEUR		640
#define FENETRE_HAUTEUR		480
#define FENETRE_COULEUR		16

SDL_Surface *g_pWindow;

void Quitter (int iValue);
void Redimensionner (int iWidth, int iHeight);
void CreerFenetre (bool bFullscreen);

///////////////////////////////// CALCULATE FRAMES PER SECOND \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*
/////
/////    This function calculates the frames we render each second and displays it to the window title
/////
///////////////////////////////// CALCULATE FRAMES PER SECOND \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*

void CalculateFrameRate()
{
    static float framesPerSecond    = 0.0f;
    static float lastTime;
    char strFrameRate[50];

    float currentTime = SDL_GetTicks() * 0.001f;                

    ++framesPerSecond;

    if( currentTime - lastTime > 1.0f )
    {
        lastTime = currentTime;
        sprintf(strFrameRate, "Nombre d'images par seconde : %d", int(framesPerSecond));
        SDL_WM_SetCaption(strFrameRate,"SDL_OGL");
        framesPerSecond = 0;
    }
}

void FastCalculateFrameRate()
{
	static int position=0,TickPrecedent=0,TempsFrames[16];
	float ImagesParSeconde=0.0f;
	int i;
    char NomFenetre[50];

	i=SDL_GetTicks();
	TempsFrames[position]=i-TickPrecedent;
	TickPrecedent=i;
	if (++position>=16)position=0;
	for (i=0;i<16;i++)
		ImagesParSeconde+=TempsFrames[i];
	ImagesParSeconde=1000.0f/((float)ImagesParSeconde/16.0f);
	sprintf(NomFenetre, "Nombre d'images par seconde : %d", (int)ImagesParSeconde);
	SDL_WM_SetCaption(NomFenetre,"SDL_OGL");
}

void Redimensionner (int iWidth, int iHeight)
{
	if (iHeight == 0)
		iHeight = 1;

    glViewport (0, 0, iWidth, iHeight);

    glMatrixMode (GL_PROJECTION);
    glLoadIdentity ();

    gluPerspective (45.f, (float)iWidth / (float)iHeight, 0.1f, 512);

    glMatrixMode (GL_MODELVIEW);
    glLoadIdentity ();
}

void CreerFenetre (bool bFullscreen)
{
    if (SDL_Init (SDL_INIT_VIDEO) < 0)
    {
        printf ("Impossible d'initializing SDL Video : %s", SDL_GetError ());
        Quitter (1);
    }

    const SDL_VideoInfo *pVideoInfo = SDL_GetVideoInfo ();

    if (pVideoInfo == NULL)
    {
        printf ("Impossible d'obtenir les informations videos : %s\n", SDL_GetError());
        Quitter (1);
    }

    if (!pVideoInfo->hw_available || !pVideoInfo->blit_hw)
		printf ("Par d'accleration hardware dtect !");

	int iVideoConf;
	if (bFullscreen)
		iVideoConf = SDL_OPENGL | SDL_HWPALETTE | SDL_FULLSCREEN | SDL_HWSURFACE | SDL_HWACCEL;
	else
		iVideoConf = SDL_OPENGL | SDL_HWPALETTE | SDL_HWSURFACE | SDL_HWACCEL;

    SDL_GL_SetAttribute (SDL_GL_DOUBLEBUFFER, 1);
    SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, FENETRE_COULEUR);
    SDL_GL_SetAttribute (SDL_GL_STENCIL_SIZE, 1);
    SDL_GL_SetAttribute (SDL_GL_ACCUM_RED_SIZE, 0);
    SDL_GL_SetAttribute (SDL_GL_ACCUM_GREEN_SIZE, 0);
    SDL_GL_SetAttribute (SDL_GL_ACCUM_BLUE_SIZE, 0);
    SDL_GL_SetAttribute (SDL_GL_ACCUM_ALPHA_SIZE, 0);

	ShowCursor(false);
	if ((g_pWindow = SDL_SetVideoMode (FENETRE_LARGEUR, FENETRE_HAUTEUR, FENETRE_COULEUR, iVideoConf)) == NULL)
	{
        printf ("Impossible de crer une fenetre : %s\n", SDL_GetError());
        Quitter (1);
    }

    SDL_WM_SetCaption (FENETRE_NOM, FENETRE_NOM);

	Redimensionner (FENETRE_LARGEUR, FENETRE_HAUTEUR);
}

int main (int argc, char* argv[])
{
	CreerFenetre (true);
	Initialisation (FENETRE_LARGEUR,FENETRE_HAUTEUR);

    while (1)
    {
		SDL_Event event;

		while (SDL_PollEvent (&event))
		{
			switch (event.type)
			{
				case SDL_QUIT:
					Quitter (0);

				case SDL_KEYDOWN:
					Quitter (0);
					break;

				default:
					break;
			}
		}

		Afficher ();
		SDL_GL_SwapBuffers ();
//		CalculateFrameRate();
	}
	return 0;
}
