#include <math.h>

#include "NormalizePlane.h"

#include "Enums.h"

void NormalizePlane(CVector4 *plane)	// normalize un plan
{
	*plane /= (float)sqrt(plane->xyzw[X]*plane->xyzw[X] + plane->xyzw[Y]*plane->xyzw[Y] + plane->xyzw[Z]*plane->xyzw[Z]);
}

CVector4 NormalizePlane(CVector4 &plane)	// normalize un plan
{
	return (plane / (float)sqrt(plane.xyzw[X]*plane.xyzw[X] + plane.xyzw[Y]*plane.xyzw[Y] + plane.xyzw[Z]*plane.xyzw[Z]));
}

CVector4 CalculatePlane(CIndice3 &v,CVector3 *c)	// calcule l'quation du plan dont fait partie un polygone
{
	// on dfini des noms plus court
#define V1x c[v.abc[A]].xyz[X]
#define V1y c[v.abc[A]].xyz[Y]
#define V1z c[v.abc[A]].xyz[Z]
#define V2x c[v.abc[B]].xyz[X]
#define V2y c[v.abc[B]].xyz[Y]
#define V2z c[v.abc[B]].xyz[Z]
#define	V3x c[v.abc[C]].xyz[X]
#define	V3y c[v.abc[C]].xyz[Y]
#define	V3z c[v.abc[C]].xyz[Z]

	return CVector4(V1y*(V2z-V3z) + V2y*(V3z-V1z) + V3y*(V1z-V2z),
					V1z*(V2x-V3x) + V2z*(V3x-V1x) + V3z*(V1x-V2x),
					V1x*(V2y-V3y) + V2x*(V3y-V1y) + V3x*(V1y-V2y),
					-( V1x*(V2y*V3z - V3y*V2z) + V2x*(V3y*V1z - V1y*V3z) + V3x*(V1y*V2z - V2y*V1z) )
					);
	// juste pour la fonction
#undef V1x
#undef V1y
#undef V1z
#undef V2x
#undef V2y
#undef V2z
#undef V3x
#undef V3y
#undef V3z
}

